package org.greenstone.mat;

import java.awt.*;
import java.awt.event.*;
import java.io.File;

import javax.swing.*;

import org.w3c.dom.Element;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;

public class CollectionChooser extends JFrame {
	
    JPanel jPanel;
    JButton jButton1;
    JComboBox collectionComboBox;
    String fileSeparator = File.separator;
    
    public CollectionChooser(String collectionName){
    	new MainApplication(collectionName);
    }
    
    public CollectionChooser() {
	super();
	this.setTitle("Choose a collection");
	this.setResizable(false);
	DescribeMessenger dm = new DescribeMessenger();
        dm.describe();
        
        Node cList = dm.getCollectionList();
        Element collectionList = (Element) cList;
        NodeList collectionNameList = collectionList.getElementsByTagName("collection");

        String[] collectionTemp = new String[collectionNameList.getLength()];
        
        int count =0; 
        for(int i=0; i<collectionNameList.getLength(); i++){
	    Node nameNode = collectionNameList.item(i);
	    String collName = nameNode.getAttributes().item(0).getNodeValue();;
	   
	    
	    String path = dm.site_home+fileSeparator+"collect"+fileSeparator+collName+fileSeparator+"index"+fileSeparator+"text"+fileSeparator+collName+".ldb";

	    File dbFile = new File(path);
	    if(dbFile.exists()){
	    	collectionTemp[count] = collName;
	    	count++;
	    }
        }
	
        String[] collectionStrings = new String[count];
        
        for(int i = 0; i<count; i++){
        	collectionStrings[i]= collectionTemp[i];
        }
        	
        if(collectionStrings.length==0){
        	JOptionPane.showMessageDialog(new JFrame(),"No collections available.");
        	System.exit(0);
        }
        jButton1 = new JButton("Enter");
        jButton1.setPreferredSize(new Dimension(150,30));
        jButton1.setFont(new java.awt.Font("Sans-serif", Font.BOLD, 16));
        jButton1.addActionListener(new collectionChooser_jButton1_Adapter(this));
        
        collectionComboBox = new JComboBox(collectionStrings);
        collectionComboBox.setSelectedIndex(0);
        collectionComboBox.setPreferredSize(new Dimension(150,30));
        collectionComboBox.setFont(new java.awt.Font("Sans-serif", Font.BOLD, 16));
        
        JLabel text = new JLabel();
        text.setFont(new java.awt.Font("Sans-serif", Font.BOLD, 14));
        text.setText("Available Collection");
        text.setPreferredSize(new Dimension(150,30));
        
        //Lay out the demo.
        jPanel = new JPanel();
        jPanel.setLayout(new AbsoluteLayout());
        jPanel.add(text, new AbsoluteConstraints(30,20,170,30));
        jPanel.add(collectionComboBox, new AbsoluteConstraints(30,60,170,30));
        jPanel.add(jButton1, new AbsoluteConstraints(30,120,170,30));
        jPanel.setPreferredSize(new Dimension(225,180));
        this.setContentPane(jPanel);
        
        //Display the window.
        this.pack();
        this.setVisible(true);
        this.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
    }
    
    
    /** Listens to the combo box. */
    public void jButton1_actionPerformed(ActionEvent e){ 
	String collectionName = collectionComboBox.getSelectedItem().toString();
	this.dispose();
	MainApplication ma = new MainApplication(collectionName);
    }
    
    /**
     * Create the GUI and show it.  For thread safety,
     * this method should be invoked from the
     * event-dispatching thread.
     */
    
    public static void main(String[] args) {
        //Schedule a job for the event-dispatching thread:
        //creating and showing this application's GUI.
    	if(args.length==0){
    		new CollectionChooser();
    	}
    	else if (args.length==1){
    		new CollectionChooser(args[0]);
    	}
    	else{
    		System.out.println("Sorry. This application cannot accept more than one argument.");
    	}
    }
}

class collectionChooser_jButton1_Adapter implements ActionListener {
    private CollectionChooser adaptee;
    
    collectionChooser_jButton1_Adapter(CollectionChooser adaptee) {
        this.adaptee = adaptee;
    }
    
    public void actionPerformed(ActionEvent e) {
        adaptee.jButton1_actionPerformed(e);
    }
}
