package org.greenstone.mat.servlet;

import java.io.*;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.Collection;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Map;
import java.util.Set;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;

import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;
import org.greenstone.gsdl3.*;
import org.greenstone.gsdl3.util.GlobalProperties;

public class PrintHTML {
    
    private final String NORMAL = "normal";
    private final String WORST = "worst";
    private final String BEST = "best";
    private final String title1 ="Hide Empty Metadata ,";
    private final String title2 ="Hide Completed Metadata  ,";
    private final String title3 ="Hide Documents with Empty Metadata  ,";
    private final String title4 ="Hide Documents with Completed Metadata  ,";
    private final String title5 ="No Available Graph";
    private final String metadataSet1 = "Dublin Core";
    private final String metadataSet2 = "Extracted";
    private final String spaceLeft = "<I>&laquo;";
    private final String spaceRight = "&raquo;</I>";
    private final String htmlSpace = "&nbsp;";
    private final String oddChar ="odd Character";
    private final String destination;
    private final String space ="space";
    private String hostName;
    private String cssString;
    private int port_number;
    private GlobalProperties globalProperty = null;
    private String fileSeparator = File.separator;
    
    String linkIdentifier = "";
    
    
    
    private HashMap url;

    MetadataStats mds;
    DataMaker dm;
    Calendar cl;
    SimpleDateFormat sdf;
    PrintWriter printWriter;
    
    public PrintHTML(MetadataStats ms, PrintWriter arg, int port){
	
    port_number = port;
	mds = ms;
	printWriter = arg;
	dm = new DataMaker(mds);
	cl=Calendar.getInstance(); 
	linkIdentifier = "dc.Identifier";
	destination = mds.HTMLDirectory;
	sdf = new SimpleDateFormat(" dd MMM yyyy 'at' HH:mm:ss z 'GMT'Z");
	setupMetadataLink("metadataElementURL");
	
	
	try {
		java.net.InetAddress localMachine = java.net.InetAddress.getLocalHost();
		hostName = localMachine.getHostName();
	}catch (java.net.UnknownHostException uhe) { 
			uhe.printStackTrace();
	}
	
	cssString = "<link rel=\"stylesheet\" href=\"http://"+hostName+":"+port_number+"/greenstone3/mat/script/mat.css\" type=\"text/css\" >";
    }
	
    private ArrayList getHideEmptyMetadataDetail(ArrayList dataset, String[] id, String[] metadataName){
    	
	printWriter.write("<!-- generating all possible page -->");
	printWriter.flush();
    	
	if(id.length==0 || metadataName.length==0){
	    return new ArrayList();
	}
	
	ArrayList detailList = new ArrayList();
	ArrayList alist = new ArrayList();
	ArrayList nameList = new ArrayList();
	
	for(int i = 0; i< metadataName.length; i++){
	    if(!dm.IsElementEmpty(metadataName[i])){
		alist.add(dm.getMetadataRows(metadataName[i]));
		nameList.add(metadataName[i]);
	    }
	}
	
	String[] metaDataElementName = new String[nameList.size()];
	
	for(int i = 0; i< nameList.size(); i++){
	    metaDataElementName[i] = nameList.get(i).toString();
	}
	
	if(id.length==0 || metaDataElementName.length==0){
	    return new ArrayList();
	}
	
	detailList.add(alist);
	detailList.add(id);
	detailList.add(metaDataElementName);
    	printWriter.write("<!-- generating all possible page-->");
    	printWriter.flush();
	
	return detailList;
    }
	
    private ArrayList getHideFullMetadataDetail(ArrayList dataset, String[] id, String[] metadataName){
    	
	printWriter.write("<!-- generating all possible page-->");
	printWriter.flush();
    	
	if(id.length==0 || metadataName.length==0){
	    return new ArrayList();
	}
	
	ArrayList detailList = new ArrayList();
	ArrayList alist = new ArrayList();
	ArrayList nameList = new ArrayList();
	
	for(int i = 0; i< metadataName.length; i++){
	    if(!dm.IsElementFull(metadataName[i])){
		alist.add(dm.getMetadataRows(metadataName[i]));
		nameList.add(metadataName[i]);
	    }
	}
	
	String[] metaDataElementName = new String[nameList.size()];
	
	for(int i = 0; i< nameList.size(); i++){
	    metaDataElementName[i] = nameList.get(i).toString();
	}
	
	if(id.length==0 || metaDataElementName.length==0){
	    return new ArrayList();
	}
	
	detailList.add(alist);
	detailList.add(id);
	detailList.add(metaDataElementName);
	
	printWriter.write("<!-- generating all possible page-->");
	printWriter.flush();
	
	return detailList;
    }
	
    private ArrayList getHideEmptyDocumentDetail(ArrayList dataset, String[] id, String[] metadataName){
    	
	printWriter.write("<!-- generating all possible page-->");
	printWriter.flush();
    
	if(id.length==0 || metadataName.length==0){
	    return new ArrayList();
	}
	
	ArrayList detailList = new ArrayList();
	ArrayList alist = dm.removeDocument(dataset, id, 0);
	ArrayList idList = dm.getRemovedID();
	ArrayList newIDList = new ArrayList();
	
	for(int i = 0; i< id.length; i++){
	    if(!idList.contains(id[i])){
		newIDList.add(id[i]);
	    }
	}
	
	id = new String[newIDList.size()];
	for(int i = 0; i<newIDList.size(); i++){
	    id[i] = newIDList.get(i).toString();
	}
	
	if(id.length==0 || metadataName.length==0){
	    return new ArrayList();
	}
	
	detailList.add(alist);
	detailList.add(id);
	detailList.add(metadataName);
	
	printWriter.write("<!-- generating all possible page-->");
	printWriter.flush();
	
	return detailList;
    }
    
    private ArrayList getHideFullDocumentDetail(ArrayList dataset, String[] id, String[] metadataName){
    	
	printWriter.write("<!-- generating all possible page-->");
	printWriter.flush();
    
	if(id.length==0 || metadataName.length==0){
	    return new ArrayList();
	}
	
	ArrayList detailList = new ArrayList();
	ArrayList alist = dm.removeDocument(dataset, id ,1);
	ArrayList idList = dm.getRemovedID();
	ArrayList newIDList = new ArrayList();
	
	for(int i = 0; i< id.length; i++){
	    if(!idList.contains(id[i])){
		newIDList.add(id[i]);
	    }
	}
	
	id = new String[newIDList.size()];
	for(int i = 0; i<newIDList.size(); i++){
	    id[i] = newIDList.get(i).toString();
	}
	
	if(id.length==0 || metadataName.length==0){
	    return new ArrayList();
	}
	
	detailList.add(alist);
	detailList.add(id);
	detailList.add(metadataName);
	
	printWriter.write("<!-- generating all possible page-->");
	printWriter.flush();
	
	return detailList;
    }
   
    public void generateAllPossibleGraph(ArrayList Namelist,String[]ids,String[] names,String condition){
	
	printWriter.write("<!-- generating all possible page-->");
	printWriter.flush();
    
	ArrayList dataList= Namelist;
	String[] id = ids;
	String[] metadataName = names;
    
	ArrayList alist = new ArrayList();
	ArrayList detailList = new ArrayList();
	ArrayList new_dataList = new ArrayList();
	String[] idList;
	String[] metadataNameList;
	
	//---------------------------------------------------------------------------------------------------------SS
	//-----------------------------------------------------------------------SSSS
	if(id.length==0 || metadataName.length==0){
	    generateEmptyGraph("SSSS",WORST,condition);
	    generateEmptyGraph("SSSS",BEST,condition);
	}
	
	else{
	    new_dataList = transformDataList(dataList,id);
	    WriteHTML("SSSS",new_dataList,id,metadataName,WORST,"Show completed graph",condition);
	    WriteHTML("SSSS",new_dataList,id,metadataName,BEST,"Show completed graph",condition);
	}
	//-----------------------------------------------------------------------SSSH
	detailList = getHideFullDocumentDetail(dataList,id,metadataName);
	if(detailList.size()==0){
	    generateEmptyGraph("SSSH",WORST,condition);
	    generateEmptyGraph("SSSH",BEST,condition);
	}
	else{
	    alist = (ArrayList)detailList.get(0);
	    idList = (String[])detailList.get(1);
	    metadataNameList = (String[])detailList.get(2);
	    new_dataList = transformDataList(alist,idList);
	    WriteHTML("SSSH",new_dataList,idList,metadataNameList,WORST,title4,condition);
	    WriteHTML("SSSH",new_dataList,idList,metadataNameList,BEST,title4,condition);
	}
	//-----------------------------------------------------------------------SSHS
	detailList = getHideEmptyDocumentDetail(dataList,id,metadataName);
	if(detailList.size()==0){
	    generateEmptyGraph("SSHS",WORST,condition);
	    generateEmptyGraph("SSHS",BEST,condition);
	    generateEmptyGraph("SSHH",WORST,condition);
	    generateEmptyGraph("SSHH",BEST,condition);
	}
	else{
	    alist = (ArrayList)detailList.get(0);
	    idList = (String[])detailList.get(1);
	    metadataNameList = (String[])detailList.get(2);
	    new_dataList = transformDataList(alist,idList);
	    WriteHTML("SSHS",new_dataList,idList,metadataNameList,WORST,title3,condition);
	    WriteHTML("SSHS",new_dataList,idList,metadataNameList,BEST,title3,condition);
	    //-----------------------------------------------------------------------SSHH
	    detailList = getHideFullDocumentDetail(alist,idList,metadataNameList);
	    if(detailList.size()==0){
		generateEmptyGraph("SSHH",WORST,condition);
		generateEmptyGraph("SSHH",BEST,condition);
	    }
	    else{
		alist = (ArrayList)detailList.get(0);
		idList = (String[])detailList.get(1);
		metadataNameList = (String[])detailList.get(2);
		new_dataList = transformDataList(alist,idList);
		WriteHTML("SSHH",new_dataList,idList,metadataNameList,WORST,title3+title4,condition);
		WriteHTML("SSHH",new_dataList,idList,metadataNameList,BEST,title3+title4,condition);
	    }
	}
	
	//---------------------------------------------------------------------------------------------------------SH
	ArrayList xList = new ArrayList(); 
	String[] idListCopy;
	String[] metadataNameListCopy;
	
	//-----------------------------------------------------------------------SHSS
	detailList = getHideFullMetadataDetail(dataList,id,metadataName);
	
	if(detailList.size()==0){
	    generateEmptyGraph("SHSS",WORST,condition);
	    generateEmptyGraph("SHSS",BEST,condition);
		
	    generateEmptyGraph("SHSH",WORST,condition);
	    generateEmptyGraph("SHSH",BEST,condition);
		
	    generateEmptyGraph("SHHS",WORST,condition);
	    generateEmptyGraph("SHHS",BEST,condition);
		
	    generateEmptyGraph("SHHH",WORST,condition);
	    generateEmptyGraph("SHHH",BEST,condition);
	}
	else{
	    alist = (ArrayList)detailList.get(0);
	    idList = (String[])detailList.get(1);
	    metadataNameList = (String[])detailList.get(2);
	    
	    xList = (ArrayList)alist.clone();
	    idListCopy = (String[]) idList.clone();
	    metadataNameListCopy = (String[])metadataNameList.clone();
	    new_dataList = transformDataList(alist,idList);
	    WriteHTML("SHSS",new_dataList,idList,metadataNameList,WORST,title2,condition);
	    WriteHTML("SHSS",new_dataList,idList,metadataNameList,BEST,title2,condition);
	
	    //-----------------------------------------------------------------------SHHS
	    detailList = getHideEmptyDocumentDetail((ArrayList)xList.clone(),(String[])idListCopy.clone(),(String[])metadataNameListCopy.clone());
	    if(detailList.size()==0){		
		generateEmptyGraph("SHHS",WORST,condition);
		generateEmptyGraph("SHHS",BEST,condition);
		generateEmptyGraph("SHHH",WORST,condition);
		generateEmptyGraph("SHHH",BEST,condition);
	    }
	    else{
		alist = (ArrayList)detailList.get(0);
		idList = (String[])detailList.get(1);
		metadataNameList = (String[])detailList.get(2);
		new_dataList = transformDataList(alist,idList);
		WriteHTML("SHHS",new_dataList,idList,metadataNameList,WORST,title2+title3,condition);
		WriteHTML("SHHS",new_dataList,idList,metadataNameList,BEST,title2+title3,condition);
		
		//-----------------------------------------------------------------------SHHH
		detailList = getHideFullDocumentDetail(alist,idList,metadataNameList);
		if(detailList.size()==0){		
		    generateEmptyGraph("SHHH",WORST,condition);
		    generateEmptyGraph("SHHH",BEST,condition);
		}
		else{
		    alist = (ArrayList)detailList.get(0);
		    idList = (String[])detailList.get(1);
		    metadataNameList = (String[])detailList.get(2);
		    new_dataList = transformDataList(alist,idList);
		    WriteHTML("SHHH",new_dataList,idList,metadataNameList,WORST,title2+title3+title4,condition);
		    WriteHTML("SHHH",new_dataList,idList,metadataNameList,BEST,title2+title3+title4,condition);
		}
	    }
	    
	    //-----------------------------------------------------------------------SHSH	
	    detailList = getHideFullDocumentDetail((ArrayList)xList.clone(),(String[])idListCopy.clone(),(String[])metadataNameListCopy.clone());
	    if(detailList.size()==0){		
		generateEmptyGraph("SHSH",WORST,condition);
		generateEmptyGraph("SHSH",BEST,condition);
	    }
	    else{
		alist = (ArrayList)detailList.get(0);
		idList = (String[])detailList.get(1);
		metadataNameList = (String[])detailList.get(2);
		new_dataList = transformDataList(alist,idList);
		WriteHTML("SHSH",new_dataList,idList,metadataNameList,WORST,title2+title4,condition);
		WriteHTML("SHSH",new_dataList,idList,metadataNameList,BEST,title2+title4,condition);
	    }
	}
	
	//---------------------------------------------------------------------------------------------------------HS
	ArrayList xList1 = new ArrayList(); 
	String[] idListCopy1;
	String[] metadataNameListCopy1;
	
	//-----------------------------------------------------------------------HSSS
	detailList = getHideEmptyMetadataDetail(dataList,id,metadataName);
	
	if(detailList.size()==0){
	    generateEmptyGraph("HSSS",WORST,condition);
	    generateEmptyGraph("HSSS",BEST,condition);
	    
	    generateEmptyGraph("HSHS",WORST,condition);
	    generateEmptyGraph("HSHS",BEST,condition);
		
	    generateEmptyGraph("HSHH",WORST,condition);
	    generateEmptyGraph("HSHH",BEST,condition);
		
	    generateEmptyGraph("HSSH",WORST,condition);
	    generateEmptyGraph("HSSH",BEST,condition);
	}
	else{
	    alist = (ArrayList)detailList.get(0);
	    idList = (String[])detailList.get(1);
	    metadataNameList = (String[])detailList.get(2);
	    
	    xList1 = (ArrayList)alist.clone();
	    idListCopy1 = (String[]) idList.clone();
	    metadataNameListCopy1 = (String[])metadataNameList.clone();
	
	    new_dataList = transformDataList(alist,idList);
	    WriteHTML("HSSS",new_dataList,idList,metadataNameList,WORST,title1,condition);
	    WriteHTML("HSSS",new_dataList,idList,metadataNameList,BEST,title1,condition);
	
	    //-----------------------------------------------------------------------HSHS
	    detailList = getHideEmptyDocumentDetail((ArrayList)xList1.clone(),(String[])idListCopy1.clone(),(String[])metadataNameListCopy1.clone());
	    if(detailList.size()==0){
		generateEmptyGraph("HSHS",WORST,condition);
		generateEmptyGraph("HSHS",BEST,condition);
		
		generateEmptyGraph("HSHH",WORST,condition);
		generateEmptyGraph("HSHH",BEST,condition);
	    }
	    else{
		alist = (ArrayList)detailList.get(0);
		idList = (String[])detailList.get(1);
		metadataNameList = (String[])detailList.get(2);
			
		new_dataList = transformDataList(alist,idList);
		WriteHTML("HSHS",new_dataList,idList,metadataNameList,WORST,title1+title3,condition);
		WriteHTML("HSHS",new_dataList,idList,metadataNameList,BEST,title1+title3,condition);
	
		//-----------------------------------------------------------------------HSHH
		detailList = getHideFullDocumentDetail(alist,idList,metadataNameList);
		if(detailList.size()==0){		
		    generateEmptyGraph("HSHH",WORST,condition);
		    generateEmptyGraph("HSHH",BEST,condition);
		}
		else{
		    alist = (ArrayList)detailList.get(0);
		    idList = (String[])detailList.get(1);
		    metadataNameList = (String[])detailList.get(2);
		    
		    new_dataList = transformDataList(alist,idList);
		    WriteHTML("HSHH",new_dataList,idList,metadataNameList,WORST,title1+title3+title4,condition); 
		    WriteHTML("HSHH",new_dataList,idList,metadataNameList,BEST,title1+title3+title4,condition); 
		}
	    }
	    
	    //-----------------------------------------------------------------------HSSH
	    detailList = getHideFullDocumentDetail((ArrayList)xList1.clone(),(String[])idListCopy1.clone(),(String[])metadataNameListCopy1.clone());
	    if(detailList.size()==0){
		generateEmptyGraph("HSSH",WORST,condition);
		generateEmptyGraph("HSSH",BEST,condition);
	    }
	    else{
		alist = (ArrayList)detailList.get(0);
		idList = (String[])detailList.get(1);
		metadataNameList = (String[])detailList.get(2);
		
		new_dataList = transformDataList(alist,idList);
		WriteHTML("HSSH",new_dataList,idList,metadataNameList,WORST,title1+title4,condition);
		WriteHTML("HSSH",new_dataList,idList,metadataNameList,BEST,title1+title4,condition);
	    }
	}
	
	//---------------------------------------------------------------------------------------------------------HH
	ArrayList xList2 = new ArrayList(); 
	String[] idListCopy2;
	String[] metadataNameListCopy2;
	
	//-----------------------------------------------------------------------HHSS
	detailList = getHideEmptyMetadataDetail(dataList,id,metadataName);
	if(detailList.size()==0){
	    generateEmptyGraph("HHSS",WORST,condition);
	    generateEmptyGraph("HHSS",BEST,condition);
	    
	    generateEmptyGraph("HHHS",WORST,condition);
	    generateEmptyGraph("HHHS",BEST,condition);
		
	    generateEmptyGraph("HHHH",WORST,condition);
	    generateEmptyGraph("HHHH",BEST,condition);
		
	    generateEmptyGraph("HHSH",WORST,condition);
	    generateEmptyGraph("HHSH",BEST,condition);
	}
	else{
	    alist = (ArrayList)detailList.get(0);
	    idList = (String[])detailList.get(1);
	    metadataNameList = (String[])detailList.get(2);
	    
	    detailList = getHideFullMetadataDetail(alist,idList,metadataNameList);
	    
	    if(detailList.size()==0){
		generateEmptyGraph("HHSS",WORST,condition);
		generateEmptyGraph("HHSS",BEST,condition);
			
		generateEmptyGraph("HHHS",WORST,condition);
		generateEmptyGraph("HHHS",BEST,condition);
		
		generateEmptyGraph("HHHH",WORST,condition);
		generateEmptyGraph("HHHH",BEST,condition);
			
		generateEmptyGraph("HHSH",WORST,condition);
		generateEmptyGraph("HHSH",BEST,condition);
	    }
	    else{
		alist = (ArrayList)detailList.get(0);
		idList = (String[])detailList.get(1);
		metadataNameList = (String[])detailList.get(2);
		
		xList2 = (ArrayList)alist.clone();
		idListCopy2 = (String[]) idList.clone();
		metadataNameListCopy2 = (String[])metadataNameList.clone();
		
		new_dataList = transformDataList(alist,idList);
		WriteHTML("HHSS",new_dataList,idList,metadataNameList,WORST,title1+title2,condition);
		WriteHTML("HHSS",new_dataList,idList,metadataNameList,BEST,title1+title2,condition);
		
		//---------------------------------------------------------------------- HHSH	
		detailList = getHideFullDocumentDetail((ArrayList)xList2.clone(),(String[])idListCopy2.clone(),(String[])metadataNameListCopy2.clone());
		if(detailList.size()==0){
		    generateEmptyGraph("HHSH",WORST,condition);
		    generateEmptyGraph("HHSH",BEST,condition);
		}
		else{
		    alist = (ArrayList)detailList.get(0);
		    idList = (String[])detailList.get(1);
		    metadataNameList = (String[])detailList.get(2);
		    
		    new_dataList = transformDataList(alist,idList);
		    
		    WriteHTML("HHSH",new_dataList,idList,metadataNameList,WORST,title1+title2+title4,condition);
		    WriteHTML("HHSH",new_dataList,idList,metadataNameList,BEST,title1+title2+title4,condition);
		}
		//----------------------------------------------------------------------HHHS	
		detailList = getHideEmptyDocumentDetail((ArrayList)xList2.clone(),(String[])idListCopy2.clone(),(String[])metadataNameListCopy2.clone());
		if(detailList.size()==0){
		    generateEmptyGraph("HHHS",WORST,condition);
		    generateEmptyGraph("HHHS",BEST,condition);
		    
		    generateEmptyGraph("HHHH",WORST,condition);
		    generateEmptyGraph("HHHH",BEST,condition);
		}
		else{
		    alist = (ArrayList)detailList.get(0);
		    idList = (String[])detailList.get(1);
		    metadataNameList = (String[])detailList.get(2);
	
		    new_dataList = transformDataList(alist,idList);
		    
		    WriteHTML("HHHS",new_dataList,idList,metadataNameList,WORST,title1+title2+title3,condition);
		    WriteHTML("HHHS",new_dataList,idList,metadataNameList,BEST,title1+title2+title3,condition);
		    
		    //----------------------------------------------------------------------HHHH
		    detailList = getHideFullDocumentDetail((ArrayList)alist.clone(),(String[])idList.clone(),(String[])metadataNameList.clone());
		    if(detailList.size()==0){
			generateEmptyGraph("HHHH",WORST,condition);
			generateEmptyGraph("HHHH",BEST,condition);
		    }
		    else{
			alist = (ArrayList)detailList.get(0);
			idList = (String[])detailList.get(1);
			metadataNameList = (String[])detailList.get(2);
			
			new_dataList = transformDataList(alist,idList);
			
			WriteHTML("HHHH",new_dataList,idList,metadataNameList,WORST,title1+title2+title3+title4,condition);
			WriteHTML("HHHH",new_dataList,idList,metadataNameList,BEST,title1+title2+title3+title4,condition);
		    }
		}
	    }
	}
    }
    
    private ArrayList transformDataList(ArrayList list, String[] ids){
    	
	printWriter.write("<!-- generating all possible page-->");
	printWriter.flush();
	
	ArrayList wholeList = new ArrayList();
	
	for(int i = 0; i< ids.length; i++){
	    ArrayList idList = new ArrayList();
	    for(int j = 0; j<list.size();j++){
		int[] datarows = (int[]) list.get(j);
		idList.add(new Integer (datarows[i]));
	    }
	    wholeList.add(idList);
	}
	
	for(int i = 0; i< wholeList.size(); i++){
	    ArrayList alist = (ArrayList)wholeList.get(i);
	    int[] rows = new int[alist.size()];
	    for(int j = 0; j< alist.size(); j++){
		rows[j] = ((Integer)alist.get(j)).intValue();
	    }
	    wholeList.remove(i);
	    wholeList.add(i,rows);
	}
	
	printWriter.write("<!-- generating all possible page-->");
	printWriter.flush();
    
	return wholeList;
	
    }
    
    private void generateEmptyGraph(String fileName,String condition,String suffix){
        
	printWriter.write("<!-- generating all possible page-->");
        printWriter.flush();
        
	String suf = suffix;
        if(!suffix.equalsIgnoreCase("dublin")){
        	suf = "other";
        }
	
    	String cases = condition; 
    	String collectionFolder = mds.getCollectionName();
	
	try{
	    FileWriter fstream = new FileWriter(destination+suf+"_"+fileName+"_"+cases+".html");
	    BufferedWriter out = new BufferedWriter(fstream);
	    out.write("<!-- This comment keeps IE6/7 in the reliable quirks mode -->\r\n");
	    out.write("<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\" \"http://www.w3.org/TR/html4/loose.dtd\">\r\n");
	    out.write("<html>\r\n");
	    out.write("<head>\r\n<title> No Available Chart</title>\r\n");   
	    out.write("<meta http-equiv=\"content-type\" content=\"text/html; charset=utf-8\">\r\n");
	    out.write("<link rel=\"stylesheet\" href=\"../script/doby2.css\" type=\"text/css\"/>\r\n");
	    out.write("</head>\r\n");
	    out.write("<p><a href=\" Overall.html \">Summary</a></p>");
	    out.write("<body>\r\n");
	    out.write("<p>No data available to render chart.</p>\r\n");
	    out.write("<p>Reason: Document number is zero or Metadata element number is zero </p>\r\n");
	    out.write("</body></html>\r\n");
	    out.close();
	    fstream.close();
	    
    	}catch(Exception e){}
	
	printWriter.write("<!-- generating all possible page-->");
	printWriter.flush();
    }
    
    private void WriteHTML(String fileName, ArrayList dataset, String[] ids, String[] metadataName, String condition, String title, String suffix){
 
    	int blueDot = 0;
    	String cases = condition; 
        String suf = suffix;
        if(!suffix.equalsIgnoreCase("dublin")){
        	suf = "other";
        }
	try{
	    printWriter.write("<!-- generating all possible page-->");
	    printWriter.flush();

	    ArrayList tempList = mds.getMetadataNameList();
	    ArrayList urlIDList;
	    if(tempList.contains("dc.Identifier") && linkIdentifier.equals("dc.Identifier")){
	    	urlIDList = dm.getURLMap("dc.Identifier");
	    }
	    else if(tempList.contains("nzir_internal.Link") && linkIdentifier.equals("nzir_internal.Link")){
	    	urlIDList = dm.getURLMap("nzir_internal.Link");
	    }
	    else{
	    	urlIDList = new ArrayList();
	    }

	    FileWriter fstream = new FileWriter(destination+suf+"_"+fileName+"_"+cases+".html");
	    BufferedWriter out = new BufferedWriter(fstream);

	    out.write("<!-- This comment keeps IE6/7 in the reliable quirks mode -->\r\n");
	    out.write("<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\" \"http://www.w3.org/TR/html4/loose.dtd\">\r\n");
	    out.write("<html>\r\n");
	    out.write("<head>\r\n<title>"+title+"</title>\r\n");
	    out.write("<meta http-equiv=\"content-type\" content=\"text/html; charset=utf-8\">\r\n");
	    out.write("<link rel=\"stylesheet\" href=\"../script/doby2.css\" type=\"text/css\"/>\r\n");
	    out.write("<script type=\"text/javascript\" src=\"../script/getInfomation.js\"></script>\r\n");
	    out.write("<script type=\"text/javascript\" src=\"http://yui.yahooapis.com/2.4.1/build/yahoo/yahoo-min.js\"></script>\r\n");
	    out.write("<script type=\"text/javascript\" src=\"http://yui.yahooapis.com/2.4.1/build/event/event-min.js\"></script>\r\n");
	    out.write("<script type=\"text/javascript\" src=\"http://yui.yahooapis.com/2.4.1/build/connection/connection-min.js\"></script>\r\n");
	    out.write("</head>\r\n");
	    out.write ("<p><a href=\" Overall.html \">Summary</a></p>");
	    out.write("<body id=\""+mds.getCollectionName()+"\" onLoad=\"reconfig()\">\r\n");
	    out.write("<div id=\"container\">\r\n");
	    out.write("<div class=\"tableContainer\">\r\n");
	    out.write ("<table cellspacing=\"0\">\r\n");   
	    out.write ("<thead>\r\n");
	    out.write ("<tr>\r\n");
	    out.write("<td class=\"qh\">Info\r\n");
	    out.write("<td class=\"qh\">URL\r\n");
	    
	    for(int a = 0; a< metadataName.length; a++){
	    	out.write("<td>"+ metadataName[a]+"\r\n");
	    }

	    out.write ("</thead>\r\n<tfoot>\r\n<tr>\r\n");
	    out.write("<td class=\"qh\">&nbsp;\r\n");
	    out.write("<td class=\"qh\">&nbsp;\r\n");
	    
	    for(int a = 0; a< metadataName.length; a++){
	    	out.write("<td>"+ dm.Mean(metadataName[a])+"%\r\n");
	    }
	    
	    out.write ("</tfoot>\r\n<tbody>\r\n");
	    
	    if(cases.equals("normal")){
	    	for(int i = ids.length; i>0; i--){
		    out.write ("<tr>");
		    int[] datarows = (int[])dataset.get(i-1);
		    
		    for(int j = 0; j<datarows.length; j++){
			
			if(datarows[j]==1){
			    out.write ("<td class=\"b\">");
			    blueDot++;
			}
			else {
			    out.write ("<td>&nbsp;");
			}
		    }
	    	}
	    }
	    else{
	    	ArrayList idList = new ArrayList();
	    	for(int i = 0; i<ids.length;i++){
	    		idList.add(ids[i]);
	    	}
	    	
	    	
	    	HashMap hp = new HashMap();
	    	
	    	for(int i = ids.length; i>0; i--){
		    String idValue = ids[i-1];
		    int dots = 0;
		    int[] datarows = (int[])dataset.get(i-1);
		    for(int j = 0; j<datarows.length; j++){
			if(datarows[j]==1){
			    dots++;
			}	
		    }
		    hp.put(idValue,new Integer(dots));
		    
	    	}
	    	ArrayList alist = dm.sortMap(hp);
	    	String[] idIntValue = new String[alist.size()]; 
		for(int i = 0; i< alist.size(); i++){
		    Map.Entry entry = (Map.Entry) alist.get(i);
		    String idElement = ((String) entry.getKey());
		    idIntValue[i] = idElement;
		}
		
		if(cases.equals("worst")){

		    for(int i = 0; i<idIntValue.length; i++){
			
		        printWriter.write("<!-- generating all possible page -->");
		        printWriter.flush(); 
		        
	    		int value = idList.indexOf(idIntValue[i]);
	    		int[] datarows = (int[])dataset.get(value);

	    		out.write ("<tr id=\""+idIntValue[i].substring(4)+"\">\r\n");
	    		out.write("<td class=\"E\" onclick=\"GD(this)\">&nbsp;\r\n");

	    		if(urlIDList.contains(idIntValue[i])){
			    out.write("<td class=\"qh\" onclick=\"GX(this)\"><span title=\"open URL in new window\">open</span>\r\n");
	    		}
	    		else{
	    			out.write("<td>\r\n");
	    		}
			
	    		for(int j = 0; j<datarows.length; j++){
		    
			    if(datarows[j]==1){
				out.write ("<td class=\"b\">\r\n");
				blueDot++;
			    }
			    else {
				out.write ("<td class=\"w\">\r\n");
			    }
	    		}
		    }
		}
		
		if(cases.equals("best")){
		    
		    for(int i = idIntValue.length; i>0; i--){
			printWriter.write("<!-- generating all possible page -->");
		        printWriter.flush();
		        
	    		int value = idList.indexOf(idIntValue[i-1]);
	    		int[] datarows = (int[])dataset.get(value);

	    		out.write ("<tr id=\""+idIntValue[i-1].substring(4)+"\">\r\n");
	    		out.write("<td class=\"E\" onclick=\"GD(this)\">&nbsp;\r\n");
	    		
	    		if(urlIDList.contains(idIntValue[i-1])){
			    out.write("<td class=\"qh\" onclick=\"GX(this)\"><span title=\"open URL in new window\">open</span>\r\n");
	    		}
	    		else{
			    out.write("<td>\r\n");
	    		}
	    		
	    		for(int j = 0; j<datarows.length; j++){
			    
			    if(datarows[j]==1){
				out.write ("<td class=\"b\">\r\n");
				blueDot++;
			    }
			    else {
				out.write ("<td class=\"w\">\r\n");
			    }
	    		}
		    }
		}
	    }
	    
	    out.write ("</tbody>\r\n");
	    out.write ("</table>\r\n</div></div>\r\n");

	    int t1 = ids.length;
	    int t3 = metadataName.length;
	    int t4 = t1*t3;
	    
	    out.write("<table>\r\n<tbody class=\"table1\">");
	    out.write("<tr>\r\n");
	    
	    HashMap tempMap = mds.getMetadataSetMap();
	    MetadataSet ms = (MetadataSet)tempMap.get(suffix);
	    
	    out.write("<td class=\"bfont\">This subset shows "+t1+" out of "+mds.getDocNum()+" documents");
	    out.write("<td class=\"bfont\">"+blueDot+" out of "+(mds.getDocNum()*t3)+" metadata items  are defined");
	    out.write("<tr>\r\n");
	    out.write("<td class=\"bfont\">This subset shows "+t3+" out of "+(ms.getIndexsList().size())+" metadata elements");
	    out.write("<td class=\"bfont\">Subset completeness: "+dm.round((double)(blueDot*100/t4),5)+"%");
	    out.write("</table>\r\n");
	    out.write ("<p> <a href=\"Overall.html \">Summary</a></p>");
	    out.write ("</body></html>");
	    //Close the output stream
	    
	    out.close();
	    fstream.close();
	}catch (Exception e){
	    e.printStackTrace(printWriter);
	}
	
	printWriter.write("<!-- generating all possible page-->");
	printWriter.flush();
    }

    
    public void generateOverallStatisticsPage(HashMap MetadataSetMap){

    	String fileName = "Overall";
	ArrayList wholeList = new ArrayList();
    	HashMap hp = mds.getMetadataSetMap();
    	Collection c = hp.values();
    	Iterator i = c.iterator();
    	int counter = 0;
    	String[][] MetadataData = new String[c.size()][2];
    	
	while(i.hasNext()){
	    MetadataSet mds  = (MetadataSet)i.next();
	    wholeList.add(mds);
	    ArrayList newMDS  = new ArrayList();
	    newMDS.add(mds);
    		
	    MetadataData[counter][0] = mds.getName();
	    MetadataData[counter][1] = dm.getSingleMetadataSetCompleteness(newMDS)+"%";

	    counter++;
    	}

    	try{
    	    printWriter.write("<!-- generating all possible page-->");
    	    printWriter.flush();
    	    
	    String str = sdf.format(cl.getTime());
	    String collectionFolder = mds.getCollectionName();

	    FileWriter fstream = new FileWriter(destination+fileName+".html");
    	    BufferedWriter out = new BufferedWriter(fstream);
    	    
    	    out.write("<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\" \"http://www.w3.org/TR/html4/loose.dtd\">");
    	    out.write("<html>\r\n");
    	    out.write("<head><title>Summary</title>\r\n");
    	    out.write("<meta http-equiv=\"content-type\" content=\"text/html; charset=utf-8\">\r\n");
	    out.write("<style type=\"text/css\">\r\n");
    	    out.write(".tam{height:20; text-align:right}\r\n");
    	    out.write("th{height:20; text-align:left}\r\n");
    	    out.write("body{font-family: Arial;}\r\n");
    	    out.write("</style>\r\n");    	    
    	    out.write("<script type=\"text/javascript\" src=\"../script/status3.js\"></script>\r\n");
    	    out.write("</head>\r\n");
	    out.write("<body>\r\n");
    	    out.write ("<td> <div style=\"float:left;\"> <a href=\"http://"+hostName+":"+port_number+"/greenstone3/mat\">Mat Home</a></div>");
    	    out.write("<div style=\"float:right;\"><a href=\"http://chnm.gmu.edu/tools/surveys/4386/\">Please send feedback about the Mat tool</a></div></td><br>");
    	    out.write("<h3 align=\"center\">Summary</h3>\r\n");
    	    out.write("<table border=1 align=\"center\">\r\n");
    	    out.write("<colgroup width=\"300\" span=\"2\">\r\n");
    	    out.write("<tr>\r\n");
    	    out.write("<th>OAI URL: </th>\r\n");
	    
    	    if(mds.getOAIURL().length()>50){
    	    	out.write("<td class=\"tam\"><font size=\"2px\"><a href=\""+mds.getOAIURL()+"\">"+mds.getOAIURL().substring(0,47)+"....</a></font>\r\n");
    	    }
    	    else{
    	    	out.write("<td class=\"tam\"><font size=\"2px\"><a href=\""+mds.getOAIURL()+"\">"+mds.getOAIURL()+"</a></font>\r\n");
    	    }
	    
    	    out.write("</tr>\r\n");
    	    out.write("<tr>\r\n");
    	    out.write("<th>Number of Records:\r\n");
    	    out.write("<td class=\"tam\">"+mds.getDocNum()+"\r\n");
    	    out.write("</tr>\r\n");
	    out.write("<table border=1 align=\"center\">\r\n");
    	    out.write("<colgroup width=\"300\" span=\"2\">\r\n");
    	    out.write("<tr>\r\n");
    	    out.write("<th>Metadata:\r\n");
    	    out.write("<td class=\"tam\"><b>Completeness</b>\r\n");
    	    out.write("</tr><br>\r\n");

    	    for(int a = 0; a<MetadataData.length; a++){
    	    	out.write ("<tr>\r\n");
    	    	if(MetadataData[a][0].equalsIgnoreCase("dublin")){
		    out.write ("<th><a href =\""+MetadataData[a][0]+".html\">"+metadataSet1+"</a>");
    	    	}
    	    	else if (MetadataData[a][0].equalsIgnoreCase("extracted")){
		    out.write ("<th><a href =\""+MetadataData[a][0]+".html\">"+metadataSet2+"</a>");
    	    	}
    	    	else{
		    out.write ("<th><a href =\""+MetadataData[a][0]+".html\">"+MetadataData[a][0]+"</a>");
    	    	}
		out.write ("<td class=\"tam\"> "+MetadataData[a][1]);
    	    	out.write ("</tr>\r\n");
    	    }
	    
    	    out.write ("</table>");
    	    out.write("<br>\r\n");
    	    out.write("<FORM  name=\"test\" onsubmit=\"checkStatus()\" action=\"\">");
    	    out.write("<table border=1 align=\"center\">\r\n");
    	    out.write ("<colgroup width=\"606\" span=\"1\">\r\n");
    	    out.write("<tr>\r\n<th>Customize Visualization");
    	    out.write("<tr>\r\n<td><LABEL FOR=\"H1\"><INPUT align=\"left\" TYPE=\"checkbox\" ID=\"H1\">Hide Empty Metadata Elements</LABEL>");
    	    out.write("<tr>\r\n<td><LABEL FOR=\"H2\"><INPUT align=\"left\" TYPE=\"checkbox\" ID=\"H2\">Hide Completed Metadata Elements</LABEL>");
    	    out.write("<tr>\r\n<td><LABEL FOR=\"H3\"><INPUT align=\"left\" TYPE=\"checkbox\" ID=\"H3\">Hide Documents with Empty Metadata Elements</LABEL>");
    	    out.write("<tr>\r\n<td><LABEL FOR=\"H4\"><INPUT align=\"left\" TYPE=\"checkbox\" ID=\"H4\">Hide Documents with  Completed Metadata Elements</LABEL>");
    	    out.write("<tr>\r\n<th>Metadata: ");
    	        	    
    	    if(MetadataData.length==1){
		if(MetadataData[0][0].equalsIgnoreCase("dublin")){
		    out.write("<tr>\r\n<td><LABEL FOR=\"C1\"><INPUT align=\"left\" TYPE=\"radio\" name = \"col\" ID=\"C1\" checked> Dublin Core </LABEL>");
		}
		else {
		    out.write("<tr>\r\n<td><LABEL FOR=\"C4\"><INPUT align=\"left\" TYPE=\"radio\" name = \"col\" ID=\"C4\" checked>"+MetadataData[0][0]+"</LABEL>");
		}
    	    }
    	    else{
    	    	for(int a = 0; a<MetadataData.length; a++){
		    if(a==0){
			if(MetadataData[a][0].equalsIgnoreCase("dublin")){
			    out.write("<tr>\r\n<td><LABEL FOR=\"C1\"><INPUT align=\"left\" TYPE=\"radio\" name = \"col\" ID=\"C1\" checked>Dublin Core</LABEL>");
			}
			else {
			    out.write("<tr>\r\n<td><LABEL FOR=\"C4\"><INPUT align=\"left\" TYPE=\"radio\" name = \"col\" ID=\"C4\" checked>"+MetadataData[a][0]+"</LABEL>");
			}
		    }
		    else{
			if(MetadataData[a][0].equalsIgnoreCase("dublin")){
			    out.write("<tr>\r\n<td><LABEL FOR=\"C1\"><INPUT align=\"left\" TYPE=\"radio\" name = \"col\" ID=\"C1\">"+MetadataData[a][0]+"</LABEL>");
			}
			else{
			    out.write("<tr>\r\n<td><LABEL FOR=\"C4\"><INPUT align=\"left\" TYPE=\"radio\" name = \"col\" ID=\"C4\">"+MetadataData[a][0]+"</LABEL>");
			}
		    }
    	    	}
    	    }
    	    
    	    out.write("<tr>\r\n<th>Order By Completeness : ");
    	    out.write("<tr>\r\n<td><LABEL FOR=\"R1\"><INPUT align=\"left\" TYPE=\"radio\" name = \"order\" ID=\"R1\">Best Case to Worst Case</LABEL>");
    	    out.write("<tr>\r\n<td><LABEL FOR=\"R2\"><INPUT align=\"left\" TYPE=\"radio\" name = \"order\" ID=\"R2\" checked >Worst Case to Best Case</LABEL>");
    	    out.write("</table><p align=\"center\"><INPUT TYPE=\"button\" VALUE=\"Show Visualization\" onClick=\"checkStatus()\"> </FORM>");
    	    out.write("<p align=\"center\">"+str+"</p>");
    	    out.write("</body></html>");
    	    
    	    out.close();
    	    fstream.close();
    	}catch (Exception e){
	    System.err.println("Error: " + e.getMessage());
    	}
	printWriter.write("<!-- generating all possible page-->");
	printWriter.flush();
    }
    
    public void WriteMetadataSetDetailHTML(MetadataSet mdset){
    
	String fileName = mdset.getName();

    	try{
    	    printWriter.write("<!-- generating all possible page-->");
    	    printWriter.flush();
    	    
	    String str = sdf.format(cl.getTime());
	    String collectionFolder = mds.getCollectionName();

	    FileWriter fstream = new FileWriter(destination+fileName+".html");
    	    BufferedWriter out = new BufferedWriter(fstream);
    	    
	    out.write("<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\" \"http://www.w3.org/TR/html4/loose.dtd\">");
    	    out.write("<html>\r\n");
    	    out.write("<head>\r\n<title>Metadata Detail</title>\r\n");
    	    out.write("<meta http-equiv=\"content-type\" content=\"text/html; charset=utf-8\">\r\n");
     	    out.write("<style type=\"text/css\">\r\n");
    	    out.write("td{height:20;text-align:right;}\r\n");
    	    out.write("th{height:20;text-align:left;}\r\n");
    	    out.write("body{font-family: Arial;}\r\n");
    	    out.write("</style>\r\n");
    	    out.write( "</head>\r\n");
    	    out.write ("<body>\r\n");
    	    out.write ("<td> <div style=\"float:left;\"> <a href=\" Overall.html \">Summary</a></div>");
    	    out.write("<div style=\"float:right;\"><a href=\"http://chnm.gmu.edu/tools/surveys/4386/\">Please send feedback about the Mat tool</a></div></td><br>");
	    if(fileName.equalsIgnoreCase("dublin")){
		out.write ("<h3 align=\"center\">Metadata Detail: "+metadataSet1+"</h3>\r\n");
	    }
	    else if (fileName.equalsIgnoreCase("extracted")){
		out.write ("<h3 align=\"center\">Metadata Detail: "+metadataSet2+"</h3>\r\n");
	    }
	    else{
		out.write ("<h3 align=\"center\">Metadata Detail: "+fileName+"</h3>\r\n");
	    }
	    
	    out.write ("<table border=\"1\" align=\"center\">\r\n");
	    out.write ("<colgroup width=\"200\" span=\"2\">\r\n");
	    out.write ("<tr>\r\n");
	    out.write ("<th>Elements:\r\n");
	    out.write ("<td><b>Completeness</b>\r\n");
	    out.write ("</tr>\r\n");
	    
	    ArrayList elementList = mdset.getIndexsList();
	    HashMap hp = new HashMap();
	    int num = elementList.size();
	    
	    for(int i = 0; i<num; i++){
		String elementName = (String)elementList.get(i);
		Double elementValue = new Double(dm.Mean(elementName));
		hp.put(elementName, elementValue);
	    }
    		
	    elementList = new ArrayList();
	    elementList = dm.sortMap(hp);
	    num = elementList.size();
	    
	    for(int i = 0; i<num; i++){
		Map.Entry entry = (Map.Entry) elementList.get(i);
		String elementName = (String) entry.getKey();
		out.write ("<tr>\r\n");
		out.write ("<th><a href=\""+ elementName +".html\">"+elementName+"</a>\r\n");
		out.write ("<td>"+ dm.Mean(elementName)+"%\r\n");
		out.write ("</tr>\r\n");
	    }
    	    
    	    out.write("</table>\r\n");
	    out.write ("<p align=\"center\"> <a href=\" Overall.html \">Summary</a></p>");
    	    out.write("<p align=\"center\">"+str+"</p>");
	    out.write ("</body></html>\r\n");
	    
	    out.close();
    	    fstream.close();
    	}catch (Exception e){
	    e.printStackTrace(printWriter);
    	}
    	
	printWriter.write("<!-- generating all possible page-->");
	printWriter.flush();
	
        }
    
    public void generateMetadataElementDetailPage(MetadataSet mds,PrintWriter out){
    	
    	ArrayList nameList = mds.getIndexsList();
    	
	for(int i = 0; i<nameList.size();i++){
	    WriteMetadataElementDetailHTML((String)nameList.get(i),mds.getName(),out);
    	}
    }
    
    public void WriteMetadataElementDetailHTML(String name, String linkName,PrintWriter outx){
    	
    	String fileName = name;
    	
    	try{
    	    printWriter.write("<!-- generating all possible page-->");
    	    printWriter.flush();

	    String collectionFolder = mds.getCollectionName();

	    FileWriter fstream = new FileWriter(destination+fileName+".html");
    	    BufferedWriter out = new BufferedWriter(fstream);

    	    out.write("<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\" \"http://www.w3.org/TR/html4/loose.dtd\">");
    	    out.write ("<html>\r\n");
    	    out.write("<head>\r\n<title> "+ name +" </title>\r\n");
    	    out.write("<meta http-equiv=\"content-type\" content=\"text/html; charset=utf-8\">\r\n");
    	    out.write("<style type=\"text/css\">\r\n");
    	    out.write("td{height:20; text-align:left;}\r\n");
    	    out.write(".tam{height:20; text-align:center}\r\n");
    	    out.write("th{height:20; text-align:left;}\r\n");
    	    out.write("body{font-family: Arial;}\r\n");
    	    out.write("</style>\r\n");
    	    out.write("<script type=\"text/javascript\" src=\"http://"+hostName+":"+port_number+"/greenstone3/mat/script/status3.js\"></script>");
    	    out.write("</head>\r\n");
	    out.write("<body>\r\n");
	    out.write ("<td> <div style=\"float:left;\"> <a href=\" Overall.html \">Summary</a></div>");
    	    out.write("<div style=\"float:right;\"><a href=\"http://chnm.gmu.edu/tools/surveys/4386/\">Please send feedback about the Mat tool</a></div></td>");
	    out.write("&raquo;");

	    if(linkName.equalsIgnoreCase("dublin")){
		out.write ("<a href=\""+linkName+".html\">Metadata Detail ("+metadataSet1+")</a>"); 
	    }
	    else if (linkName.equalsIgnoreCase("extracted")){
		out.write ("<a href=\""+linkName+".html\">Metadata Detail ("+metadataSet2+")</a>"); 
	    }
	    else{
		out.write ("<a href=\""+linkName+".html\">Metadata Detail ("+linkName+")</a>"); 	  
	    }
	    
	    if(name.startsWith("dc.")){
		int dot = name.lastIndexOf('.');
		dot++;
		String nameReplace = name.substring(dot);
		
		if(url.containsKey(nameReplace)){
		    out.write ("<h3 align=\"center\">Metadata Element Detail:<a href=\""+ url.get(nameReplace) +"\">"+ name +"</a></h3>\r\n");
		}
		else{
		    out.write ("<h3 align=\"center\">Metadata Element Detail: "+ name +"</a></h3>\r\n");
		}
	    }
	    else{
		out.write ("<h3 align=\"center\">Metadata Element Detail: "+ name +"</h3>\r\n");
	    }
	        	   
    	    out.write ("<table border=\"1\" align=\"center\" width=1000>\r\n");
    	    out.write ("<colgroup width=\"500\" span=\"2\">\r\n");
	    out.write ("<tr>\r\n");
    	    out.write ("<td><b>Total Number of Records</b>\r\n");
    	    out.write ("<td class=\"tam\">"+mds.getDocNum()+"\r\n");
	    out.write ("</tr>\r\n");
	    out.write ("<tr>\r\n");
    	    out.write ("<td><b>Unique Values</b>\r\n");
    	    out.write ("<td class=\"tam\">"+dm.getDistinctNumber(name)+"\r\n");
	    out.write ("</tr>\r\n");
	    out.write ("<tr>\r\n");
    	    out.write ("<td><b>Total times element used</b>\r\n");
    	    out.write ("<td class=\"tam\">"+dm.getFrequency(name) +"\r\n");
	    out.write ("</tr>\r\n");
	    out.write ("<tr>\r\n");
    	    out.write ("<td><b>No. of records containing element</b>\r\n");
    	    out.write ("<td class=\"tam\"> "+dm.getDocumentUsedElement(name)+"\r\n");
	    out.write ("</tr>\r\n");
	    out.write ("<tr>\r\n");

    	    double percentage = dm.Mean(name);
	    
	    out.write ("<th title = \"The completeness means the arithmetic average \"> <div style=\"float:left;\"> Completeness</div>");
	    out.write ("<td class=\"tam\"> "+dm.Mean(name) +"%\r\n");
	    out.write ("</tr>\r\n");
	    out.write ("<tr>\r\n");
	    out.write ("<td><b><div style=\"float:left;\">Minimum "+name +" usage in any record</div></b><div style=\"float:right;\"> <a href=\"#\" onClick=\"helpWindow('Minimum','"+name+"')\" style=\"font-size:small;\">What's this?</a></div>\r\n");
	    out.write ("<td class=\"tam\"> "+dm.getMinRange(name) +"\r\n");
	    out.write ("</tr>\r\n");
    		
	    out.write ("<tr>\r\n");
	    out.write ("<td><b><div style=\"float:left;\">Maximum "+name +" usage in any record</div></b><div style=\"float:right;\"> <a href=\"#\" onClick=\"helpWindow('Maximum','"+name+"')\" style=\"font-size:small;\">What's this?</a></div>\r\n");
	    out.write ("<td class=\"tam\"> "+dm.getMaxRange(name) +"\r\n");
	    out.write ("</tr>\r\n");
    		
	    out.write ("<tr>\r\n");
	    out.write ("<td><b><div style=\"float:left;\">Average "+name +" usage/record</div></b><div style=\"float:right;\"> <a href=\"#\" onClick=\"helpWindow('Average','"+name+"')\" style=\"font-size:small;\">What's this?</a></div>\r\n");
	    out.write ("<td class=\"tam\"> "+dm.Average(name) +"\r\n");
	    out.write ("</tr>\r\n");
    		
	    out.write ("<tr>\r\n");
	    out.write ("<td><b><div style=\"float:left;\">Mode of "+name +" usage/record</div></b><div style=\"float:right;\"><a href=\"#\" onClick=\"helpWindow('Mode','"+name+"')\" style=\"font-size:small;\">What's this?</a></div>\r\n");
	    out.write ("<td class=\"tam\"> "+dm.getMode(name) +"\r\n");
	    out.write ("</tr>\r\n");
	    
	    out.write ("<tr>\r\n");
	    out.write ("<td><b><div style=\"float:left;\">Coverage of the mode of "+name +" usage/record</div></b><div style=\"float:right;\"><a href=\"#\" onClick=\"helpWindow('Mode Frequency','"+name+"')\" style=\"font-size:small;\">What's this?</a></div>\r\n");
	    out.write ("<td class=\"tam\">"+dm.ModeFrequency(name) +"%\r\n");
	    out.write ("</tr>\r\n");
    		   		
	    if(mds.getOaiPrefix().equalsIgnoreCase("oai_dc")){

    		HashMap suggestionMap = generateMetadataElementSortList(fileName,"ASCII",linkName,outx);
    		
    		if(suggestionMap.size()>0){
    			boolean status = compareElement(fileName,collectionFolder,suggestionMap,linkName);
    			if(status){
			    out.write("<tr><td class=\"tam\"><a href =\""+fileName+"_Suggestion.html\">View Potential Duplicate List</a>");
			    if(percentage<100){
				out.write ("<td class=\"tam\"><a href =\""+fileName+"_IncompletedList.html\">Records missing "+fileName+"</a></td>");
				createIncompletedList(fileName,linkName,collectionFolder,outx);       
			    }
			    else{
				out.write("<td class=\"tam\">No Records Missing "+ fileName);
			    }
    			}
    			else{
			    out.write("<tr><td class=\"tam\">No Potential Duplicates");
			    if(percentage<100){
				out.write ("<td class=\"tam\"><a href =\""+fileName+"_IncompletedList.html\">Records missing "+fileName+"</a></td>");
				createIncompletedList(fileName,linkName,collectionFolder,outx);       
			    }
			    else{
				out.write("<td class=\"tam\">No Records Missing "+ fileName);
			    }
    			}
    		}
    		else{
		    out.write("<tr><td class=\"tam\">No Potential Duplicates");
		    if(percentage<100){
			out.write ("<td class=\"tam\"><a href =\""+fileName+"_IncompletedList.html\">Records missing "+fileName+"</a></td>");
			createIncompletedList(fileName,linkName,collectionFolder,outx);       
		    }
		    else{
			out.write("<td class=\"tam\">No Records Missing "+ fileName);
		    }
    		}
		generateMetadataElementSortList(fileName,"Frequency-based",linkName,outx);
	    }
	    else{
		HashMap suggestionMap = generateMetadataElementSortListNoIdentifier(fileName,"ASCII",linkName,outx);
		generateMetadataElementSortListNoIdentifier(fileName,"Frequency-based",linkName,outx);
    	   }
	    
	    out.write ("<tr>\r\n");
	    out.write ("<td class=\"tam\"><a href =\""+fileName+"_Frequency-based.html\">"+"View Full Frequency Sorted list</a>" +
		       " <td class=\"tam\"><a href =\""+fileName+"_ASCII.html\">"+"View Full ASCII Sorted list</a></td>");
	    out.write ("</tr>\r\n");
	    out.write ("</table><br>\r\n");
	    out.write ("<table border=\"1\" align=\"center\" width=1000>\r\n");
	    out.write ("<colgroup width=\"500\" span=\"2\">\r\n");
	    out.write ("<tr>\r\n");
	    out.write ("<th>ASCII-Based\r\n");
	    out.write ("<th>First Five\r\n");
	    out.write ("</tr>\r\n");
	    
	    String[] temp = dm.getSortList(name,"ASCII");
	    String[] temp2 = {"&nbsp;","&nbsp;","&nbsp;","&nbsp;","&nbsp;"};
	    int length = 0;
	    if(temp.length>=5){
		length=5;
	    }
	    else if(temp.length<5){
		length = temp.length;
	    }
	    
	    for(int i =0; i<length; i++){
		temp2[i] = temp[i];
	    }
	    
	    int x = temp2.length;
	    for(int a = 0; a<x; a++){
		out.write ("<tr>\r\n");
		if(!temp2[a].equals("&nbsp;")){
		    out.write ("<th>"+(a+1)+"\r\n");
		}
		else{
		    out.write ("<th>&nbsp;\r\n");
		}
		if(temp2[a].startsWith("http://")){
		    if(temp2[a].length()>60){
			out.write ("<td><a href = \""+temp2[a]+"\">"+temp2[a].substring(0, 60)+"...</a>");
		    }
		    else {
			out.write ("<td><a href = \""+temp2[a]+"\">"+temp2[a]+"</a>");
		    }
		}
		else{
		    char singleChar = temp2[a].charAt(0);
		    if(temp2[a].length()>61 ){
			if(temp2[a].startsWith(" ") && ((int)singleChar!=65279)){
			    temp2[a] = temp2[a].substring(1);
			    out.write ("<td>"+spaceLeft+space+spaceRight+temp2[a].substring(0, 60)+"<a href=\""+fileName+"_ASCII.html#topFive\"> ... </a>\r\n");
			}
			else if (((int)singleChar==65279)){
			    temp2[a] = temp2[a].substring(1);
			    out.write ("<td>"+spaceLeft+oddChar+spaceRight+temp2[a].substring(0, 60)+"<a href=\""+fileName+"_ASCII.html#topFive\"> ... </a>\r\n");
			}
			else{
			    out.write ("<td>"+temp2[a].substring(0, 60)+"<a href=\""+fileName+"_ASCII.html#topFive\"> ... </a>\r\n");
			}
		    }
		    else {
			if(temp2[a].startsWith(" ")&& ((int)singleChar!=65279)){
			    temp2[a] = temp2[a].substring(1);
			    out.write ("<td>"+spaceLeft+space+spaceRight+temp2[a]+"\r\n");
			}
			else if (((int)singleChar==65279)){
			    temp2[a] = temp2[a].substring(1);
			    out.write ("<td>"+spaceLeft+oddChar+spaceRight+temp2[a]+"\r\n");
			}
			else{
			    out.write ("<td>"+temp2[a]+"\r\n");
			}
		    }
		}
		out.write ("</tr>\r\n");
	    }
	    
	    String[] temp3 ={"&nbsp;","&nbsp;","&nbsp;","&nbsp;","&nbsp;"};
	    length = 0;
	    int start = temp.length;
	    
	    if(temp.length>=5){
		length= 5;
	    }
	    else if(temp.length<5){
		length = temp.length;
	    }
                
	    for(int i = length; i>0; i--){
		temp3[i-1] = temp[start-1];
		start--;
	    }
	    
	    out.write ("<tr>\r\n");
	    out.write ("<th>......\r\n");
	    out.write ("<th>Last Five\r\n");
	    out.write ("</tr>\r\n");
	    
	    int counter = temp.length;
	    start = temp.length;
	    x = temp3.length;
	    
	    for(int a = 0; a<x; a++){
		out.write ("<tr>\r\n");
		
		if(!temp3[a].equals("&nbsp;")){
		    out.write ("<th>"+(start-length+1+a));
		}
		else{
		    out.write ("<th>&nbsp;");
		}
		if(temp3[a].startsWith("http://")){
		    if(temp3[a].length()>60){
			out.write ("<td><a href = \""+temp3[a]+"\">"+temp3[a].substring(0, 60)+"...</a>");
		    }
		    else {
			out.write ("<td><a href = \""+temp3[a]+"\">"+temp3[a]+"</a>");
		    }
		}
		else{
		    char singleChar = temp3[a].charAt(0);
		    if(temp3[a].length()>61){
			if(temp3[a].startsWith(" ") && (int)singleChar!=65279){
			    temp3[a] = temp3[a].substring(1);
			    out.write ("<td>"+spaceLeft+space+spaceRight+temp3[a].substring(0, 60)+"<a href=\""+fileName+"_ASCII.html#lastFive\"> ... </a>\r\n");
			}
			else if((int)singleChar==65279){
			    temp3[a] = temp3[a].substring(1);
			    out.write ("<td>"+spaceLeft+oddChar+spaceRight+temp3[a].substring(0, 60)+"<a href=\""+fileName+"_ASCII.html#lastFive\"> ... </a>\r\n");
			    
			}
			else{
			    out.write ("<td>"+temp3[a].substring(0, 60)+"<a href=\""+fileName+"_ASCII.html#lastFive\"> ... </a>\r\n");
			}
		    }
		    else{
			if(temp3[a].startsWith(" ")&& (int)singleChar!=65279){
			    temp3[a] = temp3[a].substring(1);
			    out.write ("<td>"+spaceLeft+space+spaceRight+temp3[a]+"\r\n");
			}
			else if((int)singleChar==65279){
			    out.write ("<td>"+spaceLeft+oddChar+spaceRight+temp3[a]+"\r\n");
			}
			else{
			    out.write ("<td>"+temp3[a]+"\r\n");
			}
		    }
		    out.write ("</tr>\r\n");
		}
	    }
	    out.write ("</table><br>\r\n");
	    out.write ("<table border=\"1\" align=\"center\" width=1000>\r\n");
	    out.write ("<colgroup width=\"500\" span=\"2\">\r\n");
	    out.write ("<tr>\r\n");
	    out.write ("<th>Frequency-Based:\r\n");
	    out.write ("<th>First Five\r\n");
	    out.write ("</tr>\r\n");
	    
	    HashMap xMap = dm.getDistinctValueMap(name);
	    temp = dm.getSortList(name,"Frequency-based");
	    temp2 = new String[] {"&nbsp;","&nbsp;","&nbsp;","&nbsp;","&nbsp;"};
	    length = 0;
	    
	    if(temp.length>=5){
		length=5;
	    }
	    else if(temp.length<5){length = temp.length;}
            
	    for(int i =0; i<length; i++){
		temp2[i] = temp[i];
	    }
	    
	    ArrayList tempList = new ArrayList();
	    
	    for(int i =0; i<length; i++){
		if(((Integer)xMap.get(temp2[i])).intValue()==1){
		    tempList.add(temp2[i]);
		}
	    }
	    
	    x = temp2.length;
	    for(int a = 0; a<x; a++){
		out.write ("<tr>\r\n");
		
		if(!temp2[a].equals("&nbsp;")){
		    char singleChar = temp2[a].charAt(0);
		    out.write ("<th>"+(a+1)+". (No. of occurrences: "+((Integer)xMap.get(temp2[a])).toString()+")\r\n");
		    if(temp2[a].startsWith("http://")  && (int)singleChar != 65279){
			if(temp2[a].length()>61){
			    out.write ("<td><a href = \""+temp2[a]+"\">"+temp2[a].substring(0, 60)+"...</a>");
			}
			else {
			    out.write ("<td><a href = \""+temp2[a]+"\">"+temp2[a]+"</a>");
			}
		    }
		    
		    else{
			if(temp2[a].length()>61){
			    
			    if(temp2[a].startsWith(" ")){
				temp2[a] = temp2[a].substring(1);	
				out.write ("<td>"+spaceLeft+space+spaceRight+temp2[a].substring(0, 60)+"<a href=\""+fileName+"_Frequency-based.html#topFive\"> ... </a>\r\n");
			    }
			    
			    else if((int)singleChar == 65279){
				temp2[a] = temp2[a].substring(1);	
				out.write ("<td>"+spaceLeft+oddChar+spaceRight+temp2[a].substring(0, 60)+"<a href=\""+fileName+"_Frequency-based.html#topFive\"> ... </a>\r\n");
			    }
			    else{
				out.write ("<td>"+temp2[a].substring(0, 60)+"<a href=\""+fileName+"_Frequency-based.html#topFive\"> ... </a>\r\n");
			    }
			    
			}
			else{
			    if(temp2[a].startsWith(" ")){
				temp2[a] = temp2[a].substring(1);
				out.write ("<td>"+spaceLeft+space+spaceRight+temp2[a]+"\r\n");
			    }
			    else if((int)singleChar == 65279){
				temp2[a] = temp2[a].substring(1);	
				out.write ("<td>"+spaceLeft+oddChar+spaceRight+temp2[a]+"\r\n");
			    }
			    else{
				out.write ("<td>"+temp2[a]+"\r\n");
			    }
			}
		    }
		}
		else{
		    out.write ("<th>&nbsp;\r\n");
		    out.write ("<td>\r\n");
		}
		out.write ("</tr>\r\n");
	    }

	    temp3 = new String[]{"&nbsp;","&nbsp;","&nbsp;","&nbsp;","&nbsp;"};
	    length = 0;
	    start = temp.length;
	    if(temp.length>=5){length= 5;}
	    else if(temp.length<5){length = temp.length;}
            
	    for(int i = length; i>0; i--){
		temp3[i-1] = temp[start-1];
		start--;
	    }

    		out.write ("<tr>\r\n");
    		out.write ("<th>......\r\n");
    		out.write ("<th>Last Five\r\n");
    		out.write ("</tr>\r\n");
    		
    		x = temp3.length;
    		start = temp.length;
        	for(int a = 0; a<x; a++){
		    out.write ("<tr>\r\n");
		    if(!temp3[a].equals("&nbsp;")){

        		
			out.write ("<th>"+(start-length+1+a)+". (No. of occurrences: "+((Integer)xMap.get(temp3[a])).toString()+")\r\n");
        		
	    	char singleChar = temp3[a].charAt(0);
            		if(temp3[a].startsWith("http://")){
			    if(temp3[a].length()>60){
				out.write ("<td><a href = \""+temp3[a]+"\">"+temp3[a].substring(0, 60)+"...</a>");          			
			    }
			    else {
				out.write ("<td><a href = \""+temp3[a]+"\">"+temp3[a]+"</a>");
			    }
            		}
            		else{
			    if(temp3[a].length()>61){
            			
				if(temp3[a].startsWith(" ")){
				    temp3[a] = temp3[a].substring(1);
				    out.write ("<td>"+spaceLeft+space+spaceRight+temp3[a].substring(0, 60)+"<a href=\""+fileName+"_Frequency-based.html#lastFive\"> ... </a>\r\n");
				}
				else if((int)singleChar == 65279){
					temp3[a] = temp3[a].substring(1);
				    out.write ("<td>"+spaceLeft+oddChar+spaceRight+temp3[a].substring(0, 60)+"<a href=\""+fileName+"_Frequency-based.html#lastFive\"> ... </a>\r\n");
				
				}
				else{
				    out.write ("<td>"+temp3[a].substring(0, 60)+"<a href=\""+fileName+"_Frequency-based.html#lastFive\"> ... </a>\r\n");
				}
            			
			    }
			    else{
				if(temp3[a].startsWith(" ")){
				    out.write ("<td>"+spaceLeft+space+spaceRight+temp3[a]+"\r\n");
				}
				
				else if((int)singleChar == 65279){
					temp3[a] = temp3[a].substring(1);
				    out.write ("<td>"+spaceLeft+oddChar+spaceRight+temp3[a]+"\r\n");
				
				}
				
				else{
				    out.write ("<td>"+temp3[a]+"\r\n");
				}
			    }
            		}
            		
        		}
		    else{
			//out.write ("<th>"+(a+1)+"\r\n");
			out.write ("<th>&nbsp;\r\n");
			out.write ("<th>\r\n");
		    }
		    out.write ("</tr>\r\n");
        	}
    		
    		
    	    out.write ("</table>\r\n");

    	    ///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
    	    out.write ("<p> <a href=\" Overall.html \">Summary</a>");
    	    out.write ("&raquo;");
    	    
	    if(linkName.equalsIgnoreCase("dublin")){
		out.write ("<a href=\""+linkName+".html\">Metadata Detail ("+metadataSet1+")</a>"); 

	    }
	    else if (linkName.equalsIgnoreCase("extracted")){
		out.write ("<a href=\""+linkName+".html\">Metadata Detail ("+metadataSet2+")</a>"); 

	    }
	    else{
		out.write ("<a href=\""+linkName+".html\">Metadata Detail ("+linkName+")</a>"); 	  
	    }
    	    //out.write(str+"</p>");
    	    out.write ("</body></html>\r\n");

    	    //Close the output stream
    	    out.close();
    	    fstream.close();
    	}catch (Exception e){

	    e.printStackTrace(printWriter);
    	}
    	
	    printWriter.write("<!-- generating all possible page-->");
	    printWriter.flush();
    	//System.out.println("detail ends");
    	
    }
    
    
    private HashMap generateMetadataElementSortList(String title, String sort, String metadataSetName,PrintWriter outx){

    	String fileName = title+"_"+sort;
    	String collectionFolder = mds.getCollectionName();

    	String IDENTIFIER = linkIdentifier;
    	SearchLink sl = new SearchLink(mds.StatsDirectory);
    	HashMap suggestionMap = new HashMap();
    	
    	HashMap valueMap = sl.createValueMap(title,collectionFolder);

    	HashMap linkMap = sl.createLinkMap(IDENTIFIER,collectionFolder);
    	HashMap internalIDMap = dm.getInternalIdentifier(title);	
    	boolean status = false;
 
    	try{
    	    printWriter.write("<!-- generating all possible page-->");
    	    printWriter.flush();
    	
	    FileWriter fstream = new FileWriter(destination+fileName+".html");
	    BufferedWriter out = new BufferedWriter(fstream);
	    
	    out.write("<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\" \"http://www.w3.org/TR/html4/loose.dtd\">");
	    out.write ("<html>\r\n");
	    out.write("<head>\r\n<title>Metadata Element Sort List</title>\r\n");
	    out.write("<meta http-equiv=\"content-type\" content=\"text/html; charset=utf-8\">\r\n");
	    out.write("<script type=\"text/javascript\" src=\"../script/getInfomation.js\"></script>\r\n");   	    
	    out.write("<script type=\"text/javascript\" src=\"http://yui.yahooapis.com/2.4.1/build/yahoo/yahoo-min.js\"></script>\r\n");
	    out.write("<script type=\"text/javascript\" src=\"http://yui.yahooapis.com/2.4.1/build/event/event-min.js\"></script>\r\n");
	    out.write("<script type=\"text/javascript\" src=\"http://yui.yahooapis.com/2.4.1/build/connection/connection-min.js\"></script>\r\n");

	    out.write("<style type=\"text/css\">\r\n");
	    out.write("td{height:20; text-align:left;padding-left:5px;}\r\n");
	    out.write(".tam{height:20; text-align:center}\r\n");
	    out.write("th{height:20; text-align:center;}\r\n");
	    out.write("body{font-family: Arial;}\r\n");
	    out.write("</style>\r\n");
	    out.write("</head><body id=\""+collectionFolder+"\">\r\n");
    	
	    out.write("<td><div style=\"float:left;\"><a href=\" Overall.html \">Summary</a>");
	    out.write("&raquo;");
	    ////////////////////////////////////////////////////////////////////////////////////
	    if(metadataSetName.equalsIgnoreCase("dublin")){
		out.write ("<a href=\""+metadataSetName+".html\">Metadata Detail ("+metadataSet1+")</a>"); 
	    }
	    else if (metadataSetName.equalsIgnoreCase("extracted")){
    		out.write ("<a href=\""+metadataSetName+".html\">Metadata Detail ("+metadataSet2+")</a>"); 
	    }
	    else{
    		out.write ("<a href=\""+metadataSetName+".html\">Metadata Detail ("+metadataSetName+")</a>"); 	  
	    }
	    out.write("&raquo;");
	    out.write("<a href=\""+title+".html\">"+title+"</a></div>"); 
	    out.write("<div style=\"float:right;\"><a href=\"http://chnm.gmu.edu/tools/surveys/4386/\">Please send feedback about the Mat tool</a></div></td><br>");
 	  
	  	
	    String[] list = dm.getSortList(title, sort);
    
       	
	    if(list.length>=1){
    		
    		
    		if(sort.equals("ASCII")){
    			
            	out.write("<table border=\"1\" align=\"center\" width=\"800\">\r\n");
            	out.write ("<h2 align=\"center\">"+ title+"</h2>\r\n");      	
            	out.write ("<th class=\"tam\">ASCII Sort\r\n");
            	out.write ("<th class=\"tam\">Element Values\r\n");
            	out.write ("<th class=\"tam\">Source Documents\r\n");   
            	out.write ("<th class=\"tam\">Internal Link\r\n"); 
            	
		out.write ("<a name='topFive'>\r\n");
        		
		int counter = 0;

		for(int i = 0; i<list.length; i++){
		    if(list.length<=5 && i==0){
			out.write ("<a name='lastFive'>\r\n");
		    }
		    else if((list.length>5) && (list.length-5==i)){
			out.write ("<a name='lastFive'>\r\n");
		    }
		    
		    
        	InternalLink il= (InternalLink)internalIDMap.get(list[i]);
        	ArrayList alist2 = il.retrieveList();
        	String id = (String)alist2.get(0);
        	id = id.substring(4);
        	out.write("<tr id=\""+id+"\" >\r\n");

    				
		    if(list[i].length()>=201){
			if(list[i].startsWith("http://")){

				if(title.equals(IDENTIFIER)){
					if(list[i].length()>=100){
						out.write("<td>"+(counter+1)+"<td><a href=\""+list[i]+"\">"+list[i].substring(0,100)+"...</a>");
	
					}
					else{
						out.write("<td>"+(counter+1)+"<td><a href=\""+list[i]+"\">"+list[i]+"</a>");
					}
						out.write("<td><a href=\""+list[i]+"\">Source</a>\r\n");
				}
				else{
					ArrayList alist= sl.CreateIndentifierLinkPage(title, list[i],IDENTIFIER, collectionFolder,valueMap,linkMap);
					
					if(list[i].length()>=100){
						String url = (String)alist.get(0);
						if(alist.size()==1){
							out.write("<td>"+(counter+1)+"<td><a href=\""+list[i]+"\">"+list[i].substring(0,100)+"...</a>");
							if(url.startsWith("http://")){
								out.write("<td><a href=\""+(String)alist.get(0)+"\">Source</a>\r\n");
							}else{
								out.write("<td>Source\r\n");
							}
						}
						else if(alist.size()>1){
							out.write("<td>"+(counter+1)+"<td><a href=\""+list[i]+"\">"+list[i].substring(0,100)+"...</a>");
							if(url.startsWith("http://")){
								out.write("<td><a href=\""+(String)alist.get(0)+"\">Source</a>...\r\n");
							}else{
								out.write("<td>Source\r\n");
							}

						}
						else{
							out.write("<td>"+(counter+1)+"<td><a href=\""+list[i]+"\">"+list[i].substring(0,100)+"</a>");
							out.write("<td>No Source Available\r\n");	
						}
						suggestionMap.put(list[i], url);
					}
					else{

						String url = (String)alist.get(0);
						if(alist.size()==1){
							out.write("<td>"+(counter+1)+"<td><a href=\""+list[i]+"\">"+list[i]+"</a>");
							//out.write("<td><a href=\""+(String)alist.get(0)+"\">Source</a>\r\n");
							if(url.startsWith("http://")){
								out.write("<td><a href=\""+(String)alist.get(0)+"\">Source</a>\r\n");
							}else{
								out.write("<td>Source\r\n");
							}
						}
						else if(alist.size()>1){
							out.write("<td>"+(counter+1)+"<td><a href=\""+list[i]+"\">"+list[i]+"</a>");
							//out.write("<td><a href=\""+(String)alist.get(0)+"\">Source</a>...\r\n");	
							if(url.startsWith("http://")){
								out.write("<td><a href=\""+(String)alist.get(0)+"\">Source</a>...\r\n");
							}else{
								out.write("<td>Source\r\n");
							}
						}
						else{
							out.write("<td>"+(counter+1)+"<td><a href=\""+list[i]+"\">"+list[i]+"</a>");
							out.write("<td>No Source Available\r\n");	
						}
						suggestionMap.put(list[i], url);
					}
				}

				
			   
			}
			else{

				 ArrayList alist= sl.CreateIndentifierLinkPage(title, list[i],IDENTIFIER, collectionFolder,valueMap,linkMap);
				    
			    //////////////////////////////////////
    						
			    if(list[i].startsWith(" ")){
			    String elements = list[i];
				list[i] = list[i].substring(1);
    				
				if(alist.size()==1){
				    out.write("<td>"+(counter+1)+"<td>"+spaceLeft+space+spaceRight+list[i].substring(0, 200)+"...<td>"+
					      "<a href=\""+(String)alist.get(0)+"\">Source</a>\r\n");
				    		suggestionMap.put(elements, (String)alist.get(0));
				}
				else if(alist.size()>1){
				    out.write("<td>"+(counter+1)+"<td>"+spaceLeft+space+spaceRight+list[i].substring(0, 200)+"...<td>"+
						      "<a href=\""+(String)alist.get(0)+"\">Source</a>...\r\n");
				    		suggestionMap.put(elements, (String)alist.get(0));
				}
				else{
				    out.write("<td>"+(counter+1)+"<td>"+spaceLeft+space+spaceRight+list[i].substring(0, 200)+"...<td>No Source Available \r\n");
					suggestionMap.put(elements, "No Source Available");
				}
			    }
			    else{
    				
				if(alist.size()==1){
				    out.write("<td>"+(counter+1)+"<td>"+list[i].substring(0, 200)+"...<td>" +
					      "<a href=\""+(String)alist.get(0)+"\">Source</a>\r\n");
				    suggestionMap.put(list[i], (String)alist.get(0));
				}
				else if(alist.size()>1){
				    out.write("<td>"+(counter+1)+"<td>"+list[i].substring(0, 200)+"...<td>" +
						      "<a href=\""+(String)alist.get(0)+"\">Source</a>...\r\n");
				    suggestionMap.put(list[i], (String)alist.get(0));
				}	
				else{
				    out.write("<td>"+(counter+1)+"<td>"+list[i].substring(0, 200)+"... <td>No Source Available\r\n");
					suggestionMap.put(list[i],"No Source Available");
				}
			    }
			}
    			
		    }
		    else{
				if(list[i].startsWith("http://")){

					if(title.equals(IDENTIFIER)){
						if(list[i].length()>=100){
							out.write("<td>"+(counter+1)+"<td><a href=\""+list[i]+"\">"+list[i].substring(0,100)+"...</a>");

						}
						else{
							out.write("<td>"+(counter+1)+"<td><a href=\""+list[i]+"\">"+list[i]+"</a>");
						}
							out.write("<td><a href=\""+list[i]+"\">Source</a>\r\n");
					}
					else{
						ArrayList alist= sl.CreateIndentifierLinkPage(title, list[i],IDENTIFIER, collectionFolder,valueMap,linkMap);
						
						if(list[i].length()>=100){
							if(alist.size()==1){
								out.write("<td>"+(counter+1)+"<td><a href=\""+list[i]+"\">"+list[i].substring(0,100)+"...</a>");
								out.write("<td><a href=\""+(String)alist.get(0)+"\">Source</a>\r\n");
							}
							else if(alist.size()>1){
								out.write("<td>"+(counter+1)+"<td><a href=\""+list[i]+"\">"+list[i].substring(0,100)+"...</a>");
								out.write("<td><a href=\""+(String)alist.get(0)+"\">Source</a>...\r\n");						
							}
							else{
								out.write("<td>"+(counter+1)+"<td><a href=\""+list[i]+"\">"+list[i]+"</a>");
								out.write("<td>No Source Available\r\n");	
							}
						}
						else{
							if(alist.size()==1){
								out.write("<td>"+(counter+1)+"<td><a href=\""+list[i]+"\">"+list[i]+"</a>");
								out.write("<td><a href=\""+(String)alist.get(0)+"\">Source</a>\r\n");
								suggestionMap.put(list[i], (String)alist.get(0));
							}
							else if(alist.size()>1){
								out.write("<td>"+(counter+1)+"<td><a href=\""+list[i]+"\">"+list[i]+"</a>");
								out.write("<td><a href=\""+(String)alist.get(0)+"\">Source</a>...\r\n");	
								suggestionMap.put(list[i], (String)alist.get(0));
							}
							else{
								out.write("<td>"+(counter+1)+"<td><a href=\""+list[i]+"\">"+list[i]+"</a>");
								out.write("<td>No Source Available\r\n");	
								suggestionMap.put(list[i],"No Source Available");
							}
						}
					}

				}
		    
    					
			else{

				 ArrayList alist= sl.CreateIndentifierLinkPage(title, list[i],IDENTIFIER, collectionFolder,valueMap,linkMap);
				   
			    if(list[i].startsWith(" ")){
			    	String elements = list[i];
				list[i] = list[i].substring(1);
    				
				if(alist.size()==1){
				    out.write("<td>"+(counter+1)+"<td>"+spaceLeft+space+spaceRight+list[i]+
					      "<td><a href=\""+(String)alist.get(0)+"\">Source</a>\r\n");
				    suggestionMap.put(list[i], (String)alist.get(0));
				}
				else if(alist.size()>1){
				    out.write("<td>"+(counter+1)+"<td>"+spaceLeft+space+spaceRight+list[i]+
					      "<td><a href=\""+(String)alist.get(0)+"\">Source</a>...\r\n");
				    suggestionMap.put(list[i], (String)alist.get(0));
				}  				
				else{
				    out.write("<td>"+(counter+1)+"<td>"+spaceLeft+space+spaceRight+list[i]+"<td>No Source Available\r\n");
				    suggestionMap.put(elements,"No Source Available");
				}

			    }
			    else{
				if(alist.size()==1){
				    out.write("<td>"+(counter+1)+"<td>"+list[i]+"<td><a href=\""+alist.get(0)+"\">Source</a>\r\n");
				    suggestionMap.put(list[i],(String)alist.get(0));
				}
				else if(alist.size()>1){
				    out.write("<td>"+(counter+1)+"<td>"+list[i]+"<td><a href=\""+alist.get(0)+"\">Source</a>...\r\n");
				    suggestionMap.put(list[i],(String)alist.get(0));
				}
				else{
				    out.write("<td>"+(counter+1)+"<td>"+list[i]+"<td>No Source Available\r\n");
				    suggestionMap.put(list[i],"No Source Available");
				}
				//out.write("<td>"+(counter+1)+"<td>"+list[i]+"\r\n");
			    }
			}
		    }
		    counter++;
		    out.write("<td onclick=\"GD(this)\">View");
		}
		if(suggestionMap.size()>1 && !title.equals(IDENTIFIER)){
    		status = true;
    	}
    		}
    		else{
    			
    			
            	out.write("<table border=\"1\" align=\"center\" width=\"800\">\r\n");
            	out.write ("<h2 align=\"center\">"+ title+"</h2>\r\n");
            	out.write ("<th class=\"tam\">&nbsp;\r\n");
            	out.write ("<th class=\"tam\">Frequency\r\n");
            	out.write ("<th class=\"tam\">Element Values\r\n");    
            	out.write ("<th class=\"tam\">Source Documents\r\n");   
            	out.write ("<th class=\"tam\">Internal Link\r\n"); 
		out.write ("<a name='topFive'>\r\n");
        		
		HashMap xMap = dm.getDistinctValueMap(title);
		int counter = 0;
		for(int i = 0; i<list.length; i++){
		    if(list.length<=5 && i==0){
			out.write ("<a name='lastFive'>\r\n");
		    }
		    else if((list.length>5) && (list.length-5==i)){
			out.write ("<a name='lastFive'>\r\n");
		    }

        	InternalLink il= (InternalLink)internalIDMap.get(list[i]);
        	ArrayList alist2 = il.retrieveList();
        	String id = (String)alist2.get(0);
        	id = id.substring(4);
        	out.write("<tr id=\""+id+"\" >\r\n");
        	
		    out.write("<td>"+(counter+1)+"<th> "+((Integer)xMap.get(list[i])).toString()+"\r\n");
    				
		    if(list[i].length()>=201){
		    	
			if(list[i].startsWith("http://")){
				if(title.equals(IDENTIFIER)){
					if(list[i].length()>=100){
						out.write("<td><a href=\""+list[i]+"\">"+list[i].substring(0,100)+"</a>");
					}
					else{
						out.write("<td><a href=\""+list[i]+"\">"+list[i]+"</a>");
					}
					
				    out.write("<td><a href=\""+list[i]+"\">Source</a>\r\n");
				}
				else{
					ArrayList alist= sl.CreateIndentifierLinkPage(title, list[i],IDENTIFIER, collectionFolder,valueMap,linkMap);
					if(list[i].length()>=100){
						if(alist.size()==1){
							out.write("<td><a href=\""+list[i]+"\">"+list[i].substring(0,100)+"</a>");
							out.write("<td><a href=\""+alist.get(0)+"\">Source</a>\r\n");
						}
						else if (alist.size()>1){
							out.write("<td><a href=\""+list[i]+"\">"+list[i].substring(0,100)+"</a>");
							out.write("<td><a href=\""+alist.get(0)+"\">Source</a>...\r\n");
						}
						else{
							out.write("<td><a href=\""+list[i]+"\">"+list[i].substring(0,100)+"</a>");
							out.write("<td>No Source Available\r\n");	
						}
					
					}
					else{
						out.write("<td><a href=\""+list[i]+"\">"+list[i]+"</a>");
					}
				}
			}
			
			
			
			
			else{
			    ArrayList alist= sl.CreateIndentifierLinkPage(title, list[i],IDENTIFIER, collectionFolder,valueMap,linkMap);
    						
			    if(list[i].startsWith(" ")){
				list[i]=list[i].substring(1);
					if(alist.size()==1){
						out.write("<td>"+spaceLeft+space+spaceRight+list[i].substring(0,200)+"...<td>"+
						"<a href=\""+(String)alist.get(0)+"\">Source</a>\r\n");
					}
					else if(alist.size()>1){
						out.write("<td>"+spaceLeft+space+spaceRight+list[i].substring(0,200)+"...<td>"+
					      "<a href=\""+(String)alist.get(0)+"\">Source</a>...\r\n");
					}
					else{
						out.write("<td>"+spaceLeft+space+spaceRight+list[i].substring(0,200)+"...<td>No Source Available\r\n");
					}
			    }
			    else{
			    	
			    	if(alist.size()==1){
			    		out.write("<td>"+list[i].substring(0,200)+"...<td>" +
					      "<a href=\""+(String)alist.get(0)+"\">Source</a>\r\n");
			    	}
			    	else if(alist.size()>1){
			    		out.write("<td>"+list[i].substring(0,200)+"...<td>"+
					      "<a href=\""+(String)alist.get(0)+"\">Source</a>...\r\n");
			    	}
			    	else{
			    		out.write("<td>"+list[i].substring(0,200)+"...<td>No Source Available\r\n");
			    	}
			    }
			}
		    }
		    else{
			if(list[i].startsWith("http://")){
				if(title.equals(IDENTIFIER)){
					if(list[i].length()>=100){
						out.write("<td><a href=\""+list[i]+"\">"+list[i].substring(0,100)+"</a>");
					}
					else{
						out.write("<td><a href=\""+list[i]+"\">"+list[i]+"</a>");
					}
				    out.write("<td><a href=\""+list[i]+"\">Source</a>\r\n");
				}
				else{
					//ArrayList alist= sl.CreateIndentifierLinkPage(title, list[i],"dc.Identifier", collectionFolder,valueMap,linkMap);
					ArrayList alist= sl.CreateIndentifierLinkPage(title, list[i],IDENTIFIER, collectionFolder,valueMap,linkMap);
					
					if(list[i].length()>=100){
						if(alist.size()==1){
							out.write("<td><a href=\""+list[i]+"\">"+list[i].substring(0,100)+"</a>");
							out.write("<td><a href=\""+(String)alist.get(0)+"\">Source</a>\r\n");
						}
						else if(alist.size()>1){
							out.write("<td><a href=\""+list[i]+"\">"+list[i].substring(0,100)+"</a>");
							out.write("<td><a href=\""+(String)alist.get(0)+"\">Source</a>...\r\n");
						}
						else{
							out.write("<td><a href=\""+list[i]+"\">"+list[i].substring(0,100)+"</a>");
							out.write("<td>No Source Available\r\n");
						}
					}
					else{
						if(alist.size()==1){
							out.write("<td><a href=\""+list[i]+"\">"+list[i]+"</a>");
							out.write("<td><a href=\""+(String)alist.get(0)+"\">Source</a>\r\n");
						}
						else if(alist.size()>1){
							out.write("<td><a href=\""+list[i]+"\">"+list[i]+"</a>");
							out.write("<td><a href=\""+(String)alist.get(0)+"\">Source</a>...\r\n");
						}
						else{
							out.write("<td><a href=\""+list[i]+"\">"+list[i]+"</a>");
							out.write("<td>No Source Available\r\n");
						}
					}
					
				}
				
			}
			else{
			    
			    ArrayList alist= sl.CreateIndentifierLinkPage(title, list[i],IDENTIFIER, collectionFolder,valueMap,linkMap);
    						
			    if(list[i].startsWith(" ")){
				list[i]=list[i].substring(1);
				if(alist.size()==1){
				    out.write("<td>"+spaceLeft+space+spaceRight+list[i]+
					      "<td><a href=\""+(String)alist.get(0)+"\">Source</a>\r\n");
				}
				else if(alist.size()>1){
				    out.write("<td>"+spaceLeft+space+spaceRight+list[i]+
					      "<td><a href=\""+(String)alist.get(0)+"\">Source</a>...\r\n");
				}
				else{
				    out.write("<td>"+spaceLeft+space+spaceRight+list[i]+"<td>No Source Available\r\n");
				}
			    }
			    else{
				if(alist.size()==1){
				    out.write("<td>"+list[i]+"<td><a href=\""+(String)alist.get(0)+"\">Source</a>\r\n");
				}
				else if(alist.size()>1){
				    out.write("<td>"+list[i]+"<td><a href=\""+(String)alist.get(0)+"\">Source</a>...\r\n");
				}
				else{
				    out.write("<td>"+list[i]+"<td>No Source Available\r\n");
				}
			    }
			}
		    }
		    counter++;
		    out.write("<td onclick=\"GD(this)\">View");
		}   		  	
    		}
    		out.write("</table>\r\n");
	    }
	    else{
    		out.write("<p>Sorry! The list is empty</p>");
    	}
	    out.write("<tr>\r\n");
    	
    	
	    out.write("<p><a href=\" Overall.html \">Summary</a>");
	    out.write("&raquo;");
	    ////////////////////////////////////////////////////////////////////////////////////
	    if(metadataSetName.equalsIgnoreCase("dublin")){
		out.write ("<a href=\""+metadataSetName+".html\">Metadata Detail ("+metadataSet1+")</a>"); 
	    }
	    else if (metadataSetName.equalsIgnoreCase("extracted")){
    		out.write ("<a href=\""+metadataSetName+".html\">Metadata Detail ("+metadataSet2+")</a>"); 
	    }
	    else{
    		out.write ("<a href=\""+metadataSetName+".html\">Metadata Detail ("+metadataSetName+")</a>"); 	  
	    }
	    out.write("&raquo;");
	    out.write("<a href=\""+title+".html\">"+title+"</a></p>"); 
	    out.write("</body></html>\r\n");
	    out.close();
	    fstream.close();
      	}catch(Exception e){

	    e.printStackTrace(outx);
    	}

  	if(status){
  		return suggestionMap;
  	}
  	else{
  		return new HashMap();
  	}
    }
    
    
    private void setupMetadataLink(String fileName){
    	
    	String destination = globalProperty.getGSDL3Home()+fileSeparator+"mat"+fileSeparator+"script"+fileSeparator+fileName+".xml";
    	   
    	try{
	    DocumentBuilderFactory docBuilderFactory = DocumentBuilderFactory.newInstance();
	    DocumentBuilder docBuilder = docBuilderFactory.newDocumentBuilder();
	    Document doc = docBuilder.newDocument();
	    //doc = docBuilder.parse (new File("/research/cc108/greenstone3/web/mat/script/"+fileName+".xml"));
	    doc = docBuilder.parse (destination);
	    Element rootNode = doc.getDocumentElement();
    		
	    NodeList listOfName = rootNode.getElementsByTagName("metadataElement");
	    url = new HashMap();
	    for(int i = 0; i<listOfName.getLength(); i++){
		Node NameNode = listOfName.item(i);
		Element docElement = (Element)NameNode;
		NodeList valueList = docElement.getElementsByTagName("URL");
		Node urlParentNode = valueList.item(0);
		String urlText = urlParentNode.getChildNodes().item(0).getNodeValue();
    		
		valueList = docElement.getElementsByTagName("name");
		Node urlNameParentNode = valueList.item(0);
		String urlNameText = urlNameParentNode.getChildNodes().item(0).getNodeValue();
    		
		url.put(urlNameText, urlText);
    		
	    }
    		
    		
    	}catch(Exception e){
	    e.printStackTrace(printWriter);
    	}
   }
     
    private void createIncompletedList(String fileName, String metadataSetName, String collectionFolder,PrintWriter outx){

    	HashMap hp = dm.getIdentifierLink(linkIdentifier);
    	String[] ids = dm.getDocumentIDList(fileName);

    	for(int i = 0; i<ids.length; i++){
    		hp.remove(ids[i]);
    	}

    	try{	
	    FileWriter fstream = new FileWriter(destination+fileName+"_IncompletedList.html");
	    BufferedWriter out = new BufferedWriter(fstream);
	    
	    out.write("<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\" \"http://www.w3.org/TR/html4/loose.dtd\">");
	    out.write ("<html>\r\n");
	    out.write("<head>\r\n<title>Incompleted Document List</title>\r\n");
	    out.write("<meta http-equiv=\"content-type\" content=\"text/html; charset=utf-8\">\r\n");
	    out.write("<style type=\"text/css\">\r\n");
	    out.write("td{height:20; text-align:left;padding-left:5px;}\r\n");
	    out.write(".tam{height:20; text-align:center}\r\n");
	    out.write("th{height:20; text-align:center;}\r\n");
	    out.write("body{font-family: Arial;}\r\n");
	    out.write("</style>\r\n");
	    out.write("</head><body>\r\n");
	    
	    out.write("<p><a href=\" Overall.html \">Summary</a>");
	    out.write("&raquo;");
	    if(metadataSetName.equalsIgnoreCase("dublin")){
    		out.write ("<a href=\""+metadataSetName+".html\">Metadata Detail ("+metadataSet1+")</a>"); 
    	}
    	else if (metadataSetName.equalsIgnoreCase("extracted")){
        		out.write ("<a href=\""+metadataSetName+".html\">Metadata Detail ("+metadataSet2+")</a>"); 
    	}
    	else{
        		out.write ("<a href=\""+metadataSetName+".html\">Metadata Detail ("+metadataSetName+")</a>"); 	  
    	}
    	out.write("&raquo;");
	    out.write("<a href=\""+fileName+".html \">"+fileName+"</a>");
	    
	    out.write("<h3 align=center>"+fileName+" does not appear in the following documents</h3>");
	    int counter = 0;
	    Set s = hp.keySet();
	    Iterator i = s.iterator();
	    out.write("<table border=1 align=center><tr><th>Document ID<th>Source Link\r\n");
	    while(i.hasNext()){
	    	counter++;
	    	String keys = (String)i.next();
	    	InternalLink il = (InternalLink) hp.get(keys);
	    	ArrayList alist = il.retrieveList();
	    	String url = (String)alist.get(0);
	    	out.write("<tr><td>"+counter+"<td><a href=\""+url+"\">"+url+"</a>\r\n");
	    }
	    out.write("</table></body></html>\r\n");
	    
	    
	    out.write("<p><a href=\" Overall.html \">Summary</a>");
	    out.write("&raquo;");
	    if(metadataSetName.equalsIgnoreCase("dublin")){
    		out.write ("<a href=\""+metadataSetName+".html\">Metadata Detail ("+metadataSet1+")</a>"); 
    	}
    	else if (metadataSetName.equalsIgnoreCase("extracted")){
        		out.write ("<a href=\""+metadataSetName+".html\">Metadata Detail ("+metadataSet2+")</a>"); 
    	}
    	else{
        		out.write ("<a href=\""+metadataSetName+".html\">Metadata Detail ("+metadataSetName+")</a>"); 	  
    	}
    	out.write("&raquo;");
	    out.write("<a href=\""+fileName+".html \">"+fileName+"</a>");
	    
	    out.close();
	    fstream.close();
    	}catch(IOException ex){ex.printStackTrace();}
    	
    	
    }
    
    public boolean compareElement(String fileName,String collectionFolder,HashMap suggestionMap, String metadataSetName){

    	boolean status = false;

	    Set kset = suggestionMap.keySet();
		ArrayList arrayList = new ArrayList();
		Iterator is = kset.iterator();
		while(is.hasNext()){
			arrayList.add((String)is.next());
		}
		HashMap distanceMap = new HashMap();
	
		int totalLength = 0;

		int arrayListLength = arrayList.size();
		int counter = 0;

		printWriter.write("<!-- generating all possible page-->");
		printWriter.flush();
		double distance ;
		try{
		for(int i = 0; i<arrayListLength; i++){
			String keyword = (String)arrayList.get(i);

			int spaceCounterFront1 = 0;
			int spaceCounterEnd1 = 0;
			String keywordClone = keyword;
			String _keywordClone = keyword;
			String bkKeyWord = keyword;

			keywordClone = removeUnusedCharacter(keywordClone);

			while(true){

				if(_keywordClone.length()>1){
				if(_keywordClone.charAt(0)==' '){
					_keywordClone = _keywordClone.substring(1);
					spaceCounterFront1++;
				}
				else{
					if(_keywordClone.charAt(_keywordClone.length()-1)==' '){
						_keywordClone = _keywordClone.substring(0,_keywordClone.length()-1);
						spaceCounterEnd1++;
					}
					else{
						break;
					}
				}
				}
				else{
					break;
				}
			}

			int keywordLength = keywordClone.length();
			totalLength = totalLength + keywordLength;
			for(int j = i+1; j<arrayListLength; j++){
				String keyword2 = (String)arrayList.get(j);
				counter ++;
				double pre_cost = 0;
				String keywordClone2 = keyword2;
				String _keywordClone2 = keyword2;
				String bkKeyWord2 = keyword2;
				costModel cm = new costModel();
				cm = removeUnusedCharacter(keywordClone2,pre_cost);
				keywordClone2 = cm.getString();
				pre_cost = cm.getCost();
				
				int spaceCounterFront2 = 0;
				int spaceCounterEnd2 = 0;
				
				while(true){
					if(_keywordClone2.length()>1){
					if(_keywordClone2.charAt(0)==' '){
						_keywordClone2 = _keywordClone2.substring(1);
						spaceCounterFront2++;
					}
					else{
						if(_keywordClone2.charAt(_keywordClone2.length()-1)==' '){
							_keywordClone2 = _keywordClone2.substring(0,_keywordClone2.length()-1);
							spaceCounterEnd2++;
						}
						else{
							break;
						}
					}}
				else{
					break;
				}
				}

				if(counter == 50000){
					printWriter.write("<!-- generating all possible page-->");
					printWriter.flush();
					counter = 0;
				}
				int keyword2Length = keywordClone2.length();

				if(keywordLength>(keyword2Length+2) || (keywordLength+2)<keyword2Length ){}
				else{

					distance = calculateEditDistance(keywordClone.toLowerCase().toCharArray(),keywordClone2.toLowerCase().toCharArray());

					distance = distance + pre_cost;

					if(distance<=2){
						if(distanceMap.containsKey(_keywordClone)){
							InternalLink il = (InternalLink)distanceMap.get(_keywordClone);
							
							String keywordHolder = _keywordClone2;
							
							while(true){
								if(keywordHolder.indexOf("  ")!=-1){
									keywordHolder = keywordHolder.replaceFirst("  ",spaceLeft+space+spaceRight+" ");
								}
								else{
									break;
								}
							}
							
							for(int a = 0; a<spaceCounterFront2; a++){
								keywordHolder = spaceLeft+space+spaceRight+keywordHolder;
							}
							for(int a = 0; a<spaceCounterEnd2; a++){
								keywordHolder = keywordHolder+spaceLeft+space+spaceRight;
							}
							
							InternalLink il2 = new InternalLink();
							il2.setValue(keywordHolder);
							if(suggestionMap.containsKey(bkKeyWord2)){
								il2.increaseElement((String)suggestionMap.get(bkKeyWord2));
								//System.out.println("input this url(3):"+(String)alistkw2.get(0));
							}
							else{
								il2.increaseElement("&nbsp;");
							}
							
							il.increaseNode(il2);

							distanceMap.put(_keywordClone, il);

						}
						else{
							InternalLink il = new InternalLink();
							String keywordHolder = _keywordClone;
							
							while(true){
								if(keywordHolder.indexOf("  ")!=-1){
									keywordHolder = keywordHolder.replaceFirst("  ",spaceLeft+space+spaceRight+" ");
								}
								else{
									break;
								}
							}
							
							for(int a = 0; a<spaceCounterFront1; a++){
								keywordHolder = spaceLeft+space+spaceRight+keywordHolder;
							}
							for(int a = 0; a<spaceCounterEnd1; a++){
								keywordHolder = keywordHolder+spaceLeft+space+spaceRight;
							}
							
							InternalLink il2 = new InternalLink();
							il2.setValue(keywordHolder);
							if(suggestionMap.containsKey(bkKeyWord)){
								il2.increaseElement((String)suggestionMap.get(bkKeyWord));

							}
							else{
								il2.increaseElement("&nbsp;");
							}
							
							il.increaseNode(il2);

							
							keywordHolder = _keywordClone2;
							
							while(true){
								if(keywordHolder.indexOf("  ")!=-1){
									keywordHolder = keywordHolder.replaceFirst("  ",spaceLeft+space+spaceRight+" ");
								}
								else{
									break;
								}
							}
							for(int a = 0; a<spaceCounterFront2; a++){
								keywordHolder = spaceLeft+space+spaceRight+keywordHolder;
							}
							for(int a = 0; a<spaceCounterEnd2; a++){
								keywordHolder = keywordHolder+spaceLeft+space+spaceRight;
							}
							
							InternalLink il3 = new InternalLink();
							il3.setValue(keywordHolder);
							if(suggestionMap.containsKey(bkKeyWord2)){
								il3.increaseElement((String)suggestionMap.get(bkKeyWord2));

							}
							else{
								il3.increaseElement("&nbsp;");
							}

							il.increaseNode(il3);

							distanceMap.put(_keywordClone, il);
						}
					}
				}

			}

		}

		
		printWriter.write("<!-- generating all possible page-->");
		printWriter.flush();

		if(distanceMap.size()!=0){
			generateHTML(distanceMap,fileName,metadataSetName);
			status = true;
		}
		}catch(Exception ex){ex.printStackTrace();}
		return status;

	}
	
	
	private void generateHTML(HashMap distanceMap, String fileName,String metadataSetName){
		printWriter.write("<!-- generating all possible page-->");
		printWriter.flush();
		
		String collectionFolder = mds.getCollectionName();
		
		try{	
		    FileWriter fstream = new FileWriter(destination+fileName+"_Suggestion.html");
		    BufferedWriter out = new BufferedWriter(fstream);
		    out.write("<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\" \"http://www.w3.org/TR/html4/loose.dtd\">");
		    out.write ("<html>\r\n");
		    out.write("<head>\r\n<title>Potential Duplicate List</title>\r\n");
		    out.write("<meta http-equiv=\"content-type\" content=\"text/html; charset=utf-8\">\r\n");
		    out.write("<style type=\"text/css\">\r\n");
		    out.write("td{height:20; text-align:left;padding-left:5px;}\r\n");
		    out.write(".tam{height:20; text-align:center}\r\n");
		    out.write("th{height:20; text-align:left;}\r\n");
		    out.write("body{font-family: Arial;}\r\n");
		    out.write("</style>\r\n");
		    out.write("</head><body>\r\n");
		    out.write("<p><a href=\" Overall.html \">Summary</a>");
		    out.write("&raquo;");
		    if(metadataSetName.equalsIgnoreCase("dublin")){
	    		out.write ("<a href=\""+metadataSetName+".html\">Metadata Detail ("+metadataSet1+")</a>"); 
	    	}
	    	else if (metadataSetName.equalsIgnoreCase("extracted")){
	        		out.write ("<a href=\""+metadataSetName+".html\">Metadata Detail ("+metadataSet2+")</a>"); 
	    	}
	    	else{
	        		out.write ("<a href=\""+metadataSetName+".html\">Metadata Detail ("+metadataSetName+")</a>"); 	  
	    	}
	    	out.write("&raquo;");
		    out.write("<a href=\""+fileName+".html \">"+fileName+"</a>");
		    out.write("<h3 align=center>Potential Duplicate List</h3>");
		    out.write("<table border=1 align=center>\r\n");

			Set s = distanceMap.keySet();
			Iterator i = s.iterator();
			while(i.hasNext()){

				String keyword = (String)i.next();
				InternalLink il = (InternalLink)distanceMap.get(keyword);

				ArrayList alist = il.retrieveNodeList();

				out.write("<tr><th>Original Text<th>Source Link\r\n");
				for(int a = 0; a<alist.size(); a++){
					InternalLink il2 = new InternalLink();
					il2 = (InternalLink)alist.get(a);
					String url = (String)il2.retrieveList().get(0);
					out.write("<tr><td>"+il2.getValue()+"<td><a href=\""+url+"\">"+url+"</a>");

				}
			    out.write("</tr>");

			}
		    out.write("</table>\r\n");
		    
		    out.write("<p><a href=\" Overall.html \">Summary</a>");
		    out.write("&raquo;");
		    if(metadataSetName.equalsIgnoreCase("dublin")){
	    		out.write ("<a href=\""+metadataSetName+".html\">Metadata Detail ("+metadataSet1+")</a>"); 
	    	}
	    	else if (metadataSetName.equalsIgnoreCase("extracted")){
	        		out.write ("<a href=\""+metadataSetName+".html\">Metadata Detail ("+metadataSet2+")</a>"); 
	    	}
	    	else{
	        		out.write ("<a href=\""+metadataSetName+".html\">Metadata Detail ("+metadataSetName+")</a>"); 	  
	    	}
	    	out.write("&raquo;");
		    out.write("<a href=\""+fileName+".html \">"+fileName+"</a>");
		    out.write("</body></html>\r\n");
		    out.close();
		    fstream.close();
		}catch(IOException ex){ex.printStackTrace();}

	}
	
	public int calculateEditDistance(char[] args1, char[] args2){

        int n = args1.length; 
        int m = args2.length; 
        if (n == 0) {
            return m;
        }
        else if (m == 0) {
            return n;
        }
        
        int[] p = new int[n + 1];
    	int[] d = new int[n + 1]; 
        int[] _d; 
        

        int i; 
        int j; 

        int cost; // cost

        for (i = 0; i <= n; i++) {
            p[i] = i;
        }
        for (j = 1; j <= m; j++) {

            d[0] = j;
            for (i = 1; i <= n; i++) {
                cost = (args1[i-1] == args2[j-1]) ? 0 : 1;
                d[i] = Math.min(Math.min(d[i - 1] + 1, p[i] + 1),
                        p[i - 1] + cost);
            }

            // copy current distance counts to 'previous row' distance counts
            _d = p;
            p = d;
            d = _d;
        }
        // our last action in the above loop was to switch d and p, so p now
        // actually has the most recent cost counts
        return p[n];
	}

    private String removeUnusedCharacter(String target){
    	//printWriter.write("<!-- generating all possible page-->");
    	//printWriter.flush();

    	// remove \n 
    	while(true){
    	    if(target.indexOf("\\n")!=-1){
    	    	target = target.replaceFirst("\\\\n","");
    	    }
    	    else{
    	    	break;
    	    }
    	}
    	
    	//remove spaces at the end of string
    	if(target.length()>1){
    	while(true){
    	   	if(target.length()>1){
    	    if(target.charAt(target.length()-1)==' '){
    	    	target = target.substring(0,target.length()-1);
    	    }
    	    else{
    	    	break;
    	    }
    	   	}
    	   	else{
    	   		break;
    	   	}
        }
    	}
    	//remove leading spaces
    	if(target.length()>1){
        while(true){

        	if(target.length()>1){
    	   if(target.charAt(0)==' '){
    		   target = target.substring(1,target.length());
    	    }
    	    else{
    	    	break;
    	    }}
        	else{
        		break;
        	}
        }
    	}	 
        //remove multiple spaces between words
        while(true){
    	   if(target.indexOf("  ")!=-1){
    		   target = target.replaceFirst("  "," ");
    	   }
    	   else{
    		   break;
    	   }
        }

    	 return target;
   }
    	
    	
   private costModel removeUnusedCharacter(String target, double cost){

    		
    	costModel cm = new costModel();
    	 
    	// remove \n plus cost 
    	while(true){

    	    if(target.indexOf("\\n")!=-1){
    	    	target = target.replaceFirst("\\\\n","");
    	    	cost = cost + 0.2;
    	    }
    	    else{
    	    	break;
    	    }
    	}
    	
    	//remove spaces at the end of string
    	if(target.length()>1){
    	while(true){
    		if(target.length()>1){
    	    if(target.charAt(target.length()-1)==' '){
    	    	target = target.substring(0,target.length()-1);
    	    	cost = cost + 0.2;
    	    }
    	    else{
    	    	break;
    	    }}
    		else{
    			break;
    		}
    	}
    	}
    	//remove leading spaces  
    	if(target.length()>1){
    	while(true){

    		if(target.length()>1){
    	    if(target.charAt(0)==' '){
    	    	target = target.substring(1,target.length());
    	    	cost = cost + 0.2;
    	    }
    	    else{
    	    	break;
    	    }}
    		else{
    			break;
    		}
    	}
    	}
        //remove multiple spaces between words
    	while(true){

    	    if(target.indexOf("  ")!=-1){
    	    	target = target.replaceFirst("  "," ");
    	    	cost = cost + 0.2;
    	    }
    	    else{
    	    	break;
    	    }
    	}

    		cm.setCost(cost);
    		cm.setString(target);

    	return cm;
        }
   

   
   private HashMap generateMetadataElementSortListNoIdentifier(String title, String sort, String metadataSetName,PrintWriter outx){
	
	    	String fileName = title+"_"+sort;
	    	String collectionFolder = mds.getCollectionName();
	    	System.out.println("level 3");
	    	SearchLink sl = new SearchLink(mds.StatsDirectory);
	    	System.out.println("level 4");
	    	HashMap suggestionMap = new HashMap();
	    	
		    HashMap internalIDMap = dm.getInternalIdentifier(title);	
	    	boolean status = false;

	    	try{
	    	printWriter.write("<!-- generating all possible page-->");
	    	printWriter.flush();
	    	
		    FileWriter fstream = new FileWriter(destination+fileName+".html");
		    BufferedWriter out = new BufferedWriter(fstream);
		    
		    out.write("<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\" \"http://www.w3.org/TR/html4/loose.dtd\">");
		    out.write ("<html>\r\n");
		    out.write("<head>\r\n<title>Metadata Element Sort List</title>\r\n");
		    out.write("<meta http-equiv=\"content-type\" content=\"text/html; charset=utf-8\">\r\n");
		    out.write("<script type=\"text/javascript\" src=\"../script/getInfomation.js\"></script>\r\n");   	    
		    out.write("<script type=\"text/javascript\" src=\"http://yui.yahooapis.com/2.4.1/build/yahoo/yahoo-min.js\"></script>\r\n");
		    out.write("<script type=\"text/javascript\" src=\"http://yui.yahooapis.com/2.4.1/build/event/event-min.js\"></script>\r\n");
		    out.write("<script type=\"text/javascript\" src=\"http://yui.yahooapis.com/2.4.1/build/connection/connection-min.js\"></script>\r\n");

		    out.write("<style type=\"text/css\">\r\n");
		    out.write("td{height:20; text-align:left;padding-left:5px;}\r\n");
		    out.write(".tam{height:20; text-align:center}\r\n");
		    out.write("th{height:20; text-align:center;}\r\n");
		    out.write("body{font-family: Arial;}\r\n");
		    out.write("</style>\r\n");
		    out.write("</head><body id=\""+collectionFolder+"\">\r\n");
	    	
		    out.write("<td><div style=\"float:left;\"><a href=\" Overall.html \">Summary</a>");
		    out.write("&raquo;");

		    if(metadataSetName.equalsIgnoreCase("dublin")){
			out.write ("<a href=\""+metadataSetName+".html\">Metadata Detail ("+metadataSet1+")</a>"); 
		    }
		    else if (metadataSetName.equalsIgnoreCase("extracted")){
	    		out.write ("<a href=\""+metadataSetName+".html\">Metadata Detail ("+metadataSet2+")</a>"); 
		    }
		    else{
	    		out.write ("<a href=\""+metadataSetName+".html\">Metadata Detail ("+metadataSetName+")</a>"); 	  
		    }
		    out.write("&raquo;");
		    out.write("<a href=\""+title+".html\">"+title+"</a></div>"); 
		  	
		    out.write("<div style=\"float:right;\"><a href=\"http://chnm.gmu.edu/tools/surveys/4386/\">Please send feedback about the Mat tool</a></div></td><br>");
	 	  
		  	
		    String[] list = dm.getSortList(title, sort);

	      
	       	
		    if(list.length>=1){
	    		
	    		
	    		if(sort.equals("ASCII")){
	    			
	            	out.write("<table border=\"1\" align=\"center\" width=\"800\">\r\n");
	            	out.write ("<h2 align=\"center\">"+ title+"</h2>\r\n");      	
	            	out.write ("<th class=\"tam\">ASCII Sort\r\n");
	            	out.write ("<th class=\"tam\">Element Values\r\n");
	            	out.write ("<th class=\"tam\">Source Documents\r\n");   
	            	out.write ("<th class=\"tam\">Internal Link\r\n"); 
	            	
			out.write ("<a name='topFive'>\r\n");
	        		
			int counter = 0;

			for(int i = 0; i<list.length; i++){

			    if(list.length<=5 && i==0){
				out.write ("<a name='lastFive'>\r\n");
			    }
			    else if((list.length>5) && (list.length-5==i)){
				out.write ("<a name='lastFive'>\r\n");
			    }
			    
			            	
	        	InternalLink il= (InternalLink)internalIDMap.get(list[i]);
	        	ArrayList alist2 = il.retrieveList();
	        	String id = (String)alist2.get(0);
	        	id = id.substring(4);
	        	out.write("<tr id=\""+id+"\" >\r\n");
	    				
			    if(list[i].length()>=201){
				if(list[i].startsWith("http://")){

						if(list[i].length()>=100){
								out.write("<td>"+(counter+1)+"<td><a href=\""+list[i]+"\">"+list[i].substring(0,100)+"</a>");
								out.write("<td><a href=\""+list[i]+"\">Source</a>\r\n");
						}
						else{
								out.write("<td>"+(counter+1)+"<td><a href=\""+list[i]+"\">"+list[i]+"</a>");
								out.write("<td><a href=\""+list[i]+"\">Source</a>\r\n");
						}
					
				}
				else{

				    if(list[i].startsWith(" ")){
				    String elements = list[i];
					list[i] = list[i].substring(1);
					    out.write("<td>"+(counter+1)+"<td>"+spaceLeft+space+spaceRight+list[i].substring(0, 200)+"...<td>No Source Available \r\n");
				    }
				    else{
					    out.write("<td>"+(counter+1)+"<td>"+list[i].substring(0, 200)+"... <td>No Source Available\r\n");
				    }
				}
	    			
			    }
			    else{
	    					

					if(list[i].startsWith("http://")){

						if(list[i].length()>=100){
							out.write("<td>"+(counter+1)+"<td><a href=\""+list[i]+"\">"+list[i].substring(0,100)+"...</a>");
						}
						else{
							out.write("<td>"+(counter+1)+"<td><a href=\""+list[i]+"\">"+list[i]+"</a>");
						}
							out.write("<td><a href=\""+list[i]+"\">Source</a>\r\n");				
					   
					}
			    

	    					
				else{
					   
				    if(list[i].startsWith(" ")){
				    String elements = list[i];
					list[i] = list[i].substring(1);

					    out.write("<td>"+(counter+1)+"<td>"+spaceLeft+space+spaceRight+list[i]+"<td>No Source Available\r\n");
					    suggestionMap.put(elements,"No Source Available");

				    }
				    else{
					    out.write("<td>"+(counter+1)+"<td>"+list[i]+"<td>No Source Available\r\n");
				    }
				}
			    }
			    counter++;
			    out.write("<td onclick=\"GD(this)\">View");
			}

	    		}
	    		else{
	    			
	    			
	            	out.write("<table border=\"1\" align=\"center\" width=\"800\">\r\n");
	            	out.write ("<h2 align=\"center\">"+ title+"</h2>\r\n");
	            	out.write ("<th class=\"tam\">&nbsp;\r\n");
	            	out.write ("<th class=\"tam\">Frequency\r\n");
	            	out.write ("<th class=\"tam\">Element Values\r\n");    
	            	out.write ("<th class=\"tam\">Source Documents\r\n");   
	            	out.write ("<th class=\"tam\">Internal Link\r\n"); 
			out.write ("<a name='topFive'>\r\n");
	        		
			HashMap xMap = dm.getDistinctValueMap(title);
			int counter = 0;
			for(int i = 0; i<list.length; i++){
			    if(list.length<=5 && i==0){
				out.write ("<a name='lastFive'>\r\n");
			    }
			    else if((list.length>5) && (list.length-5==i)){
				out.write ("<a name='lastFive'>\r\n");
			    }

	        	InternalLink il= (InternalLink)internalIDMap.get(list[i]);
	        	ArrayList alist2 = il.retrieveList();
	        	String id = (String)alist2.get(0);
	        	id = id.substring(4);
	        	out.write("<tr id=\""+id+"\" >\r\n");
	        	
			    out.write("<td>"+(counter+1)+"<th> "+((Integer)xMap.get(list[i])).toString()+"\r\n");
	    				
			    if(list[i].length()>=201){
			    	
				if(list[i].startsWith("http://")){
					if(list[i].length()>=100){
						out.write("<td><a href=\""+list[i]+"\">"+list[i].substring(0,100)+"</a>");
					}
					else{
						out.write("<td><a href=\""+list[i]+"\">"+list[i]+"</a>");
					}
					
				    out.write("<td><a href=\""+list[i]+"\">Source</a>\r\n");
				}
				
				
				
				
				else{   						
				    if(list[i].startsWith(" ")){
					list[i]=list[i].substring(1);

							out.write("<td>"+spaceLeft+space+spaceRight+list[i].substring(0,200)+"...<td>No Source Available\r\n");
					
				    }
				    else{

				    		out.write("<td>"+list[i].substring(0,200)+"...<td>No Source Available\r\n");
				    	
				    }
				}
			    }
			    else{
				if(list[i].startsWith("http://")){
					if(list[i].length()>=100){
						out.write("<td><a href=\""+list[i]+"\">"+list[i].substring(0,100)+"</a>");
					}
					else{
						out.write("<td><a href=\""+list[i]+"\">"+list[i]+"</a>");
					}
				    out.write("<td><a href=\""+list[i]+"\">Source</a>\r\n");
					
				}
				else{
	    						
				    if(list[i].startsWith(" ")){
					list[i]=list[i].substring(1);


					    out.write("<td>"+spaceLeft+space+spaceRight+list[i]+"<td>No Source Available\r\n");
					
				    }
				    else{

					    out.write("<td>"+list[i]+"<td>No Source Available\r\n");
					
				    }
				}
			    }
			    counter++;
			    out.write("<td onclick=\"GD(this)\">View");
			}   		  	
	    		}
	    		out.write("</table>\r\n");
		    }
		    else{
	    		out.write("<p>Sorry! The list is empty</p>");
	    	}
		    out.write("<tr>\r\n");
	    	
	    	
		    out.write("<p><a href=\" Overall.html \">Summary</a>");
		    out.write("&raquo;");

		    if(metadataSetName.equalsIgnoreCase("dublin")){
			out.write ("<a href=\""+metadataSetName+".html\">Metadata Detail ("+metadataSet1+")</a>"); 
		    }
		    else if (metadataSetName.equalsIgnoreCase("extracted")){
	    		out.write ("<a href=\""+metadataSetName+".html\">Metadata Detail ("+metadataSet2+")</a>"); 
		    }
		    else{
	    		out.write ("<a href=\""+metadataSetName+".html\">Metadata Detail ("+metadataSetName+")</a>"); 	  
		    }
		    out.write("&raquo;");
		    out.write("<a href=\""+title+".html\">"+title+"</a></p>"); 
		    out.write("</body></html>\r\n");
		    out.close();
		    fstream.close();
	      	}catch(Exception e){

		    e.printStackTrace(outx);
	    	}
	      	
	      	return new HashMap();
	    }
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   private void createIncompletedListNoIdentifier(String fileName, String metadataSetName, String collectionFolder,PrintWriter outx){
   	//HashMap hp = dm.getIdentifierLink("dc.Identifier");
   	HashMap hp = dm.getIdentifierLinkNoIdentifier();
   	String[] ids = dm.getDocumentIDList(fileName);
   	System.out.println("Length: "+ids.length+" "+fileName+ " "+hp.size());
   	
   	Set st = hp.keySet();
   	Iterator it = st.iterator();
   	while(it.hasNext()){
   		System.out.println(it.next());
   	}
   	for(int i = 0; i<ids.length; i++){
   		System.out.println("IDS:" +ids[i]);
   		hp.remove(ids[i]);
   	}
   	System.out.println("Length: "+ids.length+" "+fileName+ " "+hp.size());
     	//String collectionFolder = mds.getCollectionName();
   	//System.out.println(hp.size());
   	try{	
	    FileWriter fstream = new FileWriter(destination+fileName+"_IncompletedList.html");
	    BufferedWriter out = new BufferedWriter(fstream);
	    
	    out.write("<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\" \"http://www.w3.org/TR/html4/loose.dtd\">");
	    out.write ("<html>\r\n");
	    out.write("<head>\r\n<title>Incompleted Document List</title>\r\n");
	    out.write("<meta http-equiv=\"content-type\" content=\"text/html; charset=utf-8\">\r\n");
	    out.write("<style type=\"text/css\">\r\n");
	    out.write("td{height:20; text-align:left;padding-left:5px;}\r\n");
	    out.write(".tam{height:20; text-align:center}\r\n");
	    out.write("th{height:20; text-align:center;}\r\n");
	    out.write("body{font-family: Arial;}\r\n");
	    out.write("</style>\r\n");
	    out.write("</head><body>\r\n");
	    
	    out.write("<p><a href=\" Overall.html \">Summary</a>");
	    out.write("&raquo;");
	    if(metadataSetName.equalsIgnoreCase("dublin")){
   		out.write ("<a href=\""+metadataSetName+".html\">Metadata Detail ("+metadataSet1+")</a>"); 
   	}
   	else if (metadataSetName.equalsIgnoreCase("extracted")){
       		out.write ("<a href=\""+metadataSetName+".html\">Metadata Detail ("+metadataSet2+")</a>"); 
   	}
   	else{
       		out.write ("<a href=\""+metadataSetName+".html\">Metadata Detail ("+metadataSetName+")</a>"); 	  
   	}
   	out.write("&raquo;");
	    out.write("<a href=\""+fileName+".html \">"+fileName+"</a>");
	    
	    out.write("<h3 align=center>"+fileName+" does not appear in the following documents</h3>");
	    int counter = 0;
	    System.out.println("link.....");
	    Set s = hp.keySet();
	    Iterator i = s.iterator();
	    System.out.println("link2.....");
	    out.write("<table border=1 align=center><tr><th>Document ID<th>Source Link\r\n");
	    while(i.hasNext()){
	    	//printWriter.write("<!-- generating all possible page-->");
	    	System.out.println("link.....3");
	    	counter++;
	    	String keys = (String)i.next();
	    	  System.out.println("link.....4"+keys);
	    	InternalLink il = (InternalLink) hp.get(keys);
	    	
	    	ArrayList alist = il.retrieveList();
	    	  System.out.println("link.....5"+alist.size());
	    	String url = (String)alist.get(0);
	    	out.write("<tr><td>"+counter+"<td><a href=\""+url+"\">"+url+"</a>\r\n");
	    }
	    out.write("</table></body></html>\r\n");
	    
	    
	    out.write("<p><a href=\" Overall.html \">Summary</a>");
	    out.write("&raquo;");
	    if(metadataSetName.equalsIgnoreCase("dublin")){
   		out.write ("<a href=\""+metadataSetName+".html\">Metadata Detail ("+metadataSet1+")</a>"); 
   	}
   	else if (metadataSetName.equalsIgnoreCase("extracted")){
       		out.write ("<a href=\""+metadataSetName+".html\">Metadata Detail ("+metadataSet2+")</a>"); 
   	}
   	else{
       		out.write ("<a href=\""+metadataSetName+".html\">Metadata Detail ("+metadataSetName+")</a>"); 	  
   	}
   	out.write("&raquo;");
	    out.write("<a href=\""+fileName+".html \">"+fileName+"</a>");
	    
	    out.close();
	    fstream.close();
   	}catch(IOException ex){ex.printStackTrace();}
   	
   	
   }
   ///////////////////////////////////////////////////////////////////////////////////////
}

